SystemOrganization addCategory: #'Universes-Interface'!
SystemOrganization addCategory: #'Universes-Editor'!
SystemOrganization addCategory: #'Universes-Browser'!
SystemOrganization addCategory: #'Universes-Policy'!
SystemOrganization addCategory: #'Universes-Model'!
SystemOrganization addCategory: #'Universes-Tests'!
SystemOrganization addCategory: #'Universes-Server'!
SystemOrganization addCategory: #'Universes-Client'!
SystemOrganization addCategory: #'Universes-Installers'!
SystemOrganization addCategory: #'Universes-Messages'!
SystemOrganization addCategory: #'Universes-Serialization'!

Model subclass: #UAccountEditor
	instanceVariableNames: 'username password newPassword newPassword2 newEmail whenDone window fields'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Editor'!

!UAccountEditor commentStamp: '<historical>' prior: 0!
A tool for editing an account!

!UAccountEditor class methodsFor: 'class initialization' stamp: 'ls 2/13/2005 16:58'!
initialize
	Preferences setWindowColorFor: self name to: (Color r: 0.194 g: 0.645 b: 1.0).! !

!UAccountEditor class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 17:41'!
username: username0  password: password0  email: email0  whenDone: aBlock
	^self basicNew
		username: username0  password: password0  email: email0  whenDone: aBlock;
		yourself! !

!UAccountEditor methodsFor: 'user interface' stamp: 'ls 7/28/2004 17:52'!
acceptFields
	fields do: [ :f | f accept ]! !

!UAccountEditor methodsFor: 'user interface' stamp: 'ls 2/13/2005 17:40'!
morphicView
	| win column nameRow submitButton passwordRow password1Row password2Row emailRow submitButtonHolder |
	window ifNotNil: [^window].
	win := SystemWindow labelled: 'Account Editor'.
	win model: self.
	column := AlignmentMorph newColumn.
	win addMorph: column frame: (0 @ 0 extent: 1 @ 1).
	nameRow := UInterfaceUtilities 
				makeFieldRowNamed: 'name:'
				getSelector: #username
				setSelector: nil
				isPassword: false
				for: self.
	column addMorphBack: nameRow.
	passwordRow := UInterfaceUtilities 
				makeFieldRowNamed: 'password:'
				getSelector: #password
				setSelector: #password:
				isPassword: true
				for: self.
	column addMorphBack: passwordRow.
	password1Row := UInterfaceUtilities 
				makeFieldRowNamed: 'new password'
				getSelector: #password1
				setSelector: #password1:
				isPassword: true
				for: self.
	column addMorphBack: password1Row.
	password2Row := UInterfaceUtilities 
				makeFieldRowNamed: 'confirm:'
				getSelector: #password2
				setSelector: #password2:
				isPassword: true
				for: self.
	column addMorphBack: password2Row.
	emailRow := UInterfaceUtilities 
				makeFieldRowNamed: 'email:'
				getSelector: #newEmail
				setSelector: #newEmail:
				isPassword: false
				for: self.
	column addMorphBack: emailRow.
	submitButtonHolder := Morph new.	"necessary to keep SystemWindow from screwing up the colors of the button"
	submitButtonHolder
		layoutPolicy: TableLayout new;
		hResizing: #spaceFill;
		borderColor: self defaultBackgroundColor.
	submitButton := UInterfaceUtilities 
				makeButtonWithAction: #submit
				andLabel: 'Submit'
				for: self.
	submitButton
		useSquareCorners;
		borderWidth: 0.
	submitButtonHolder addMorph: submitButton.
	column addMorphBack: submitButtonHolder.
	^window := win! !

!UAccountEditor methodsFor: 'accessing' stamp: 'ls 7/28/2004 17:52'!
newEmail
	^newEmail! !

!UAccountEditor methodsFor: 'accessing' stamp: 'ls 7/28/2004 17:53'!
newEmail: anObject
	newEmail _ anObject! !

!UAccountEditor methodsFor: 'user interface' stamp: 'ls 2/13/2005 17:34'!
noteField: field 
	"note that the receiver has the specified text field"
	fields ifNil: [fields := OrderedCollection new].
	fields add: field! !

!UAccountEditor methodsFor: 'user interface' stamp: 'ls 2/13/2005 17:38'!
openInMorphic
	^self morphicView openInWorldExtent:  251@263! !

!UAccountEditor methodsFor: 'accessing' stamp: 'ls 7/28/2004 17:50'!
password
	^password! !

!UAccountEditor methodsFor: 'accessing' stamp: 'ls 7/28/2004 17:51'!
password1
	^newPassword! !

!UAccountEditor methodsFor: 'accessing' stamp: 'ls 7/28/2004 17:51'!
password1: aString
	newPassword _ aString asString.
	self changed: #password1.
	^true! !

!UAccountEditor methodsFor: 'accessing' stamp: 'ls 7/28/2004 17:51'!
password2
	^newPassword2! !

!UAccountEditor methodsFor: 'accessing' stamp: 'ls 7/28/2004 17:51'!
password2: aString
	newPassword2 _ aString asString.
	self changed: #password2.
	^true! !

!UAccountEditor methodsFor: 'accessing' stamp: 'ls 2/13/2005 16:50'!
password: aString
	password _ aString.
	self changed: #password! !

!UAccountEditor methodsFor: 'user interface' stamp: 'ls 2/13/2005 17:12'!
returnTrue
	^true! !

!UAccountEditor methodsFor: 'user interface' stamp: 'ls 2/13/2005 16:52'!
submit
	self acceptFields.
	newPassword = newPassword2 ifFalse: [
		^self inform: 'new passwords do not match!!' ].
	whenDone value: password value: newPassword value: newEmail
	! !

!UAccountEditor methodsFor: 'accessing' stamp: 'ls 7/28/2004 17:50'!
username
	^username! !

!UAccountEditor methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 17:40'!
username: username0  password: password0  email: email0  whenDone: aBlock
	username _ username0.
	password _ password0.
	newPassword _ ''.
	newPassword2 _ ''.
	newEmail _ email0.
	whenDone _ aBlock.

! !

!UAccountEditor methodsFor: 'accessing' stamp: 'ls 7/28/2004 18:01'!
window
	^window! !

Model subclass: #UPackageEditor
	instanceVariableNames: 'package whenComplete fields window'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Editor'!

!UPackageEditor commentStamp: '<historical>' prior: 0!
A simple GUI for editing a package and then doing something with it.
!

!UPackageEditor class methodsFor: 'class initialization' stamp: 'ls 2/13/2005 16:58'!
initialize
	Preferences setWindowColorFor: self name to: (Color r: 0.194 g: 0.645 b: 1.0).! !

!UPackageEditor class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 16:28'!
package: aPackage  whenComplete: aBlock
	^self basicNew
		package: aPackage  whenComplete: aBlock;
		yourself! !

!UPackageEditor methodsFor: 'user interface' stamp: 'ls 7/28/2004 16:41'!
acceptFields
	fields do: [ :f | f accept ]! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 2/13/2005 17:59'!
conflictsString
	^self stringForPackageNames: package conflicts! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 2/13/2005 17:59'!
conflictsString: aString 
	package conflicts: (self packageNamesFromString: aString).
	self changed: #conflictsString! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 2/13/2005 17:58'!
dependsString
	^self stringForPackageNames: package depends! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 2/13/2005 17:59'!
dependsString: aString 
	package depends: (self packageNamesFromString: aString).
	self changed: #dependsString! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 7/28/2004 16:40'!
description
	^package description! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 7/28/2004 16:41'!
description: aString
	package description: aString asString.
	self changed: #description.
	^true! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 2/13/2005 18:00'!
homepageString
	^package homepage
		ifNil: [ '' ]
		ifNotNil: [ package homepage toText ]! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 2/13/2005 18:01'!
homepageString: newHomePage
	newHomePage asString = ''
		ifTrue: [ package homepage: nil ]
		ifFalse: [ package homepage: (Url absoluteFromText: newHomePage asString) ].

	self changed: #homepageString! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 2/13/2005 17:59'!
maintainer
	^package maintainer! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 2/13/2005 18:00'!
maintainer: aStringOrText 
	package maintainer: aStringOrText asString.
	self changed: #maintainer! !

!UPackageEditor methodsFor: 'user interface' stamp: 'ls 7/28/2004 16:34'!
makeFieldGet: getSelector  set: setSelector
	| field fieldHeight |
	fieldHeight _ TextStyle default defaultFont pointSize + 8.
		
		
	field := PluggableTextMorph on: self text: getSelector accept: setSelector.
	field extent: 200@fieldHeight.
	field hideScrollBarsIndefinitely.
	field setProperty: #alwaysAccept toValue: true.
	
	fields ifNil: [ fields _ OrderedCollection new].
	fields add: field.
	
	^field! !

!UPackageEditor methodsFor: 'user interface' stamp: 'ls 2/15/2005 22:04'!
morphicView
	| win column nameRow versionRow urlRow descriptionField submitButton dependsRow homepageRow providesRow conflictsRow |
	window ifNotNil: [ ^window ].
	win _ SystemWindow labelled: 'Package Editor'.
	win model: self.

	column _ AlignmentMorph newColumn.
	win addMorph: column frame: (0@0  extent:  1@0.6).
	

	nameRow _ UInterfaceUtilities makeFieldRowNamed: 'name:' getSelector: #packageName setSelector: #packageName: for: self.
	column addMorphBack: nameRow.
	

	versionRow _ UInterfaceUtilities makeFieldRowNamed: 'version:' getSelector: #versionString setSelector: #versionString: for: self.
	column addMorphBack: versionRow.
	
	versionRow _ UInterfaceUtilities makeFieldRowNamed: 'maintainer:' getSelector: #maintainer setSelector: #maintainer: for: self.
	column addMorphBack: versionRow.
	
	homepageRow _ UInterfaceUtilities makeFieldRowNamed: 'homepage:' getSelector: #homepageString setSelector: #homepageString: for: self.
	column addMorphBack: homepageRow.
	
	
	
	urlRow _ UInterfaceUtilities makeFieldRowNamed: 'download from:' getSelector: #urlString setSelector: #urlString: for: self.
	column addMorphBack: urlRow.

	providesRow _ UInterfaceUtilities makeFieldRowNamed: 'provides:' getSelector: #providesString setSelector: #providesString: for: self.
	column addMorphBack: providesRow.
	
	dependsRow _ UInterfaceUtilities makeFieldRowNamed: 'depends:' getSelector: #dependsString setSelector: #dependsString: for: self.
	column addMorphBack: dependsRow.

	conflictsRow _ UInterfaceUtilities makeFieldRowNamed: 'conflicts:' getSelector: #conflictsString setSelector: #conflictsString: for: self.
	column addMorphBack: conflictsRow.

	column addMorphBack: (StringMorph contents: 'Description:').
	
	descriptionField _ self makeFieldGet: #description set: #description:.
	win addMorph: descriptionField frame: (0@0.6 extent: 1@0.3).
	
	submitButton _ UInterfaceUtilities makeButtonWithAction: #submit andLabel: 'Submit' for: self.
	win addMorph: submitButton frame: (0@0.9 extent: 1@0.1).
	
	
	^window _ win! !

!UPackageEditor methodsFor: 'user interface' stamp: 'ls 2/13/2005 17:34'!
noteField: field 
	"note that the receiver has the specified text field"
	fields ifNil: [fields := OrderedCollection new].
	fields add: field! !

!UPackageEditor methodsFor: 'user interface' stamp: 'ls 2/13/2005 18:02'!
openInMorphic
	^self morphicView openInWorldExtent: 517@488! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 7/28/2004 16:45'!
package
	^package! !

!UPackageEditor methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 16:28'!
package: aPackage  whenComplete: aBlock
	package _ aPackage.
	whenComplete _ aBlock.
	! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 7/28/2004 16:38'!
packageName
	^package name! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 7/28/2004 16:43'!
packageName: aString
	package name: aString asString.
	self changed: #packageName.
	^true! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 2/13/2005 17:59'!
packageNamesFromString: aString 
	| depNames |
	depNames := aString asString findTokens: ','.
	depNames := depNames collect: [:d | d withBlanksTrimmed].
	^depNames! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 2/13/2005 17:59'!
providesString
	^self stringForPackageNames: package provides! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 2/13/2005 17:59'!
providesString: aString 
	package provides: (self packageNamesFromString: aString).
	self changed: #providesString! !

!UPackageEditor methodsFor: 'user interface' stamp: 'ls 2/13/2005 18:05'!
returnTrue
	^true! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 2/13/2005 17:58'!
stringForPackageNames: depends 
	| first |
	first := true.
	^String streamContents: 
			[:str | 
			depends do: 
					[:depName | 
					first ifTrue: [first := false] ifFalse: [str nextPutAll: ', '].
					str nextPutAll: depName]]! !

!UPackageEditor methodsFor: 'user interface' stamp: 'ls 7/28/2004 16:43'!
submit
	self acceptFields.
	whenComplete value: package! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 10/20/2006 18:36'!
urlString
	^package url ifNotNil: [ package url toText ]! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 10/20/2006 18:10'!
urlString: aString
	| url |
	url :=
		aString asString withBlanksTrimmed isEmpty
			ifTrue: [ nil ]
			ifFalse: [ Url absoluteFromText: aString asString ].
	package url: url.
	self changed: #urlString.
	^true! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 7/28/2004 16:39'!
versionString
	^package version printString! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 7/28/2004 16:39'!
versionString: aString
	package version: (UVersion readFromString: aString).
	self changed: #versionString.
	^true! !

!UPackageEditor methodsFor: 'accessors' stamp: 'ls 7/28/2004 17:12'!
window
	^window! !

Model subclass: #UUniverse
	instanceVariableNames: 'shortName description'
	classVariableNames: 'SystemUniverse'
	poolDictionaries: ''
	category: 'Universes-Model'!

!UUniverse commentStamp: 'ls 2/13/2005 11:10' prior: 0!
Abstract.  One "package universe".  A package universe is an evolving set of packages that multiple people can participate in.  Each Squeak image is a member of exactly one universe.
!

UUniverse subclass: #UCompoundUniverse
	instanceVariableNames: 'components'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Model'!

!UCompoundUniverse commentStamp: 'ls 7/29/2004 18:48' prior: 0!
A universe that is the union of other universes.!

!UCompoundUniverse class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 18:47'!
composedOf: universes
	^self new
		components: universes;
		yourself! !

!UCompoundUniverse methodsFor: 'accessing' stamp: 'ls 2/13/2005 14:56'!
components: anObject
	components _ anObject.
	components do: [ :c | c addDependent:  self ].! !

!UCompoundUniverse methodsFor: 'packages' stamp: 'ls 1/16/2005 14:09'!
packages
	^Array streamContents: [ :pstr |
		components do: [ :univ |
			pstr nextPutAll: univ packages ] ]! !

!UCompoundUniverse methodsFor: 'accessing' stamp: 'ls 7/29/2004 18:50'!
standardUniverses
	^Array streamContents: [ :str |
		components do: [ :comp |
			str nextPutAll: comp standardUniverses  ] ]! !

!UCompoundUniverse methodsFor: 'updating' stamp: 'ls 2/13/2005 14:57'!
update: aSymbol
	aSymbol = #packages ifTrue: [ self changed: #packages ].! !

!UCompoundUniverse methodsFor: 'packages' stamp: 'ls 2/13/2005 14:58'!
updatePackagesViaWWW
	components do: [ :component | component updatePackagesViaWWW ]! !

UUniverse subclass: #UStandardUniverse
	instanceVariableNames: 'serverName serverPort packagesURL packages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Model'!

!UStandardUniverse commentStamp: 'ls 7/28/2004 10:36' prior: 0!
A universe that looks to one single server for authoritative information.
!

!UStandardUniverse methodsFor: 'packages' stamp: 'ls 2/13/2005 12:43'!
addPackage: aPackage
	"make sure that we end up with no two packages with the same name and version"
	packages removeAllSuchThat: [ :p | p name = aPackage name and: [ p version = aPackage version ] ].
	
	"now add the new package"
	packages add: aPackage.

	self changed: #packages! !

!UStandardUniverse methodsFor: 'initialize-release' stamp: 'ls 1/16/2005 14:07'!
initialize
	super initialize.
	packages _ Set new.! !

!UStandardUniverse methodsFor: 'accessing' stamp: 'ls 1/16/2005 14:07'!
packages
	^packages! !

!UStandardUniverse methodsFor: 'initialize-release' stamp: 'ls 2/13/2005 15:01'!
packages: aCollection
	packages _ Set new.
	packages addAll: aCollection.
	self changed: #packages! !

!UStandardUniverse methodsFor: 'accessing' stamp: 'ls 2/13/2005 11:13'!
packagesURL
	"a URL from which the list of packages may be downloaded"
	^packagesURL! !

!UStandardUniverse methodsFor: 'initialize-release' stamp: 'ls 2/13/2005 11:12'!
packagesURL: aURL
	packagesURL _ aURL! !

!UStandardUniverse methodsFor: 'packages' stamp: 'ls 2/13/2005 12:43'!
removePackage: aPackage
	packages remove: aPackage.

	self changed: #packages! !

!UStandardUniverse methodsFor: 'accessing' stamp: 'ls 7/28/2004 13:21'!
serverName
	^serverName! !

!UStandardUniverse methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 10:37'!
serverName: aString	
	serverName _ aString! !

!UStandardUniverse methodsFor: 'accessing' stamp: 'ls 7/28/2004 13:21'!
serverPort
	^serverPort! !

!UStandardUniverse methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 10:37'!
serverPort: port
	serverPort _ port! !

!UStandardUniverse methodsFor: 'accessing' stamp: 'ls 7/29/2004 18:09'!
standardUniverses
	^{self}! !

!UStandardUniverse methodsFor: 'packages' stamp: 'ls 2/15/2005 22:42'!
updatePackagesViaWWW
	| rawPackageList newPackages |
	packagesURL ifNil: [ ^self ].
	rawPackageList _ packagesURL retrieveContents content.
	(rawPackageList withBlanksTrimmed beginsWith: '<') ifFalse: [
		"it is possible that the universe is completely empty, but more likely there was an error retrieving the document"
		^self ].

	newPackages _ UPackage decodePackagesFromXMLStream: (ReadStream on: rawPackageList).
	self packages: newPackages! !

!UUniverse class methodsFor: 'well known' stamp: 'ls 2/15/2005 23:32'!
developmentUniverse 
	"[UUniverse switchSystemToUniverse: UUniverse developmentUniverse]"
	^UStandardUniverse new
		serverName: 'universes.dnsalias.net';
		serverPort: UUniverseMultiServer defaultPort;
		shortName: 'development';
		description: 'Development';
		packagesURL: 'http://universes.dnsalias.net:8888/~universes/repositories/development.packages' asUrl;
		yourself
! !

!UUniverse class methodsFor: 'well known' stamp: 'ls 2/13/2005 12:45'!
exampleCompoundUniverse
	"[UUniverse switchSystemToUniverse: UUniverse exampleCompoundUniverse]"
	^(UCompoundUniverse composedOf: {
		self developmentUniverse.
		self homeMoviesUniverse
	}) description: 'example compound universe'; yourself! !

!UUniverse class methodsFor: 'well known' stamp: 'ls 2/15/2005 23:33'!
homeMoviesUniverse 
	"[UUniverse switchSystemToUniverse: UUniverse homeMoviesUniverse]"
	^UStandardUniverse new
		shortName: 'homemovies';
		serverName: 'universes.dnsalias.net';
		serverPort: UUniverseMultiServer defaultPort;
		packagesURL: 'http://universes.dnsalias.net:8888/~universes/repositories/homemovies.packages' asUrl;
		description: 'Home Movies';
		yourself! !

!UUniverse class methodsFor: 'class initialization' stamp: 'ls 2/15/2005 23:42'!
initialize
	"fix up old instances, to have a proper packagesURL"
	"this method should be deleted, after suitable time has passed to allow for upgrades"

	self allSubInstancesDo: [ :universe |
		universe class == UStandardUniverse ifTrue: [
			universe packagesURL == nil ifTrue: [
				"no URL specified.  guess...."
				universe serverPort = 4129 ifTrue: [
					universe shortName: 'development'.
					universe packagesURL: 'http://universes.dnsalias.net:8888/~universes/repositories/development.packages' asUrl.
					universe serverPort: UUniverseMultiServer defaultPort. ].
				universe serverPort = 8940 ifTrue: [ 
					universe shortName: 'homevideos'.
					universe packagesURL: 'http://universes.dnsalias.net:8888/~universes/repositories/homemovies.packages' asUrl.
					universe serverPort: UUniverseMultiServer defaultPort. ].
				universe serverPort = 7273 ifTrue: [ 
					universe shortName: 'squeak37'.
					universe packagesURL: 'http://universes.dnsalias.net:8888/~universes/repositories/squeak37.packages' asUrl.
					universe serverPort: UUniverseMultiServer defaultPort. ]. ] ] ]! !

!UUniverse class methodsFor: 'well known' stamp: 'ls 2/15/2005 23:33'!
squeak37Universe 
	"[UUniverse switchSystemToUniverse: UUniverse squeak37Universe]"
	^UStandardUniverse new
		serverName: 'universes.dnsalias.net';
		serverPort: UUniverseMultiServer defaultPort;
		shortName: 'squeak37';
		description: 'Squeak 3.7';
		packagesURL: 'http://universes.dnsalias.net:8888/~universes/repositories/squeak37.packages' asUrl;
		yourself! !

!UUniverse class methodsFor: 'system' stamp: 'ls 7/29/2004 18:54'!
switchSystemToUniverse: aUniverse
	SystemUniverse _ aUniverse! !

!UUniverse class methodsFor: 'system' stamp: 'ls 2/13/2005 12:44'!
systemUniverse
	"return the universe this image uses"
	^SystemUniverse ifNil: [ SystemUniverse _ self developmentUniverse ]! !

!UUniverse methodsFor: 'packages' stamp: 'ls 7/29/2004 19:09'!
addPackages: newPackages
	newPackages do: [ :p | self addPackage: p ]! !

!UUniverse methodsFor: 'accessing' stamp: 'ls 2/13/2005 11:10'!
description
	"The description is a one-line description of the universe for human consumption."

	^description! !

!UUniverse methodsFor: 'initialize-release' stamp: 'ls 7/29/2004 16:16'!
description: aString
	description _ aString! !

!UUniverse methodsFor: 'packages' stamp: 'ls 1/16/2005 14:06'!
hasPackageNamed: name
	^self packages anySatisfy: [ :p | p name = name ].
	! !

!UUniverse methodsFor: 'initialize-release' stamp: 'ls 1/16/2005 14:07'!
initialize
	description _ 'some universe'.! !

!UUniverse methodsFor: 'packages' stamp: 'ls 7/28/2004 17:17'!
newestPackageNamed: name
	| potentials sorted |
	potentials _ self packagesNamed: name.
	sorted _ potentials asSortedCollection: [ :p1 :p2 | p1 version < p2 version ].
	^sorted last! !

!UUniverse methodsFor: 'packages' stamp: 'ls 1/16/2005 14:06'!
packageNames
	| names |
	names _ Set new.
	self packages do: [ :p | names add: p name ].
	^names! !

!UUniverse methodsFor: 'packages' stamp: 'ls 1/16/2005 14:08'!
packages
	^self subclassResponsibility! !

!UUniverse methodsFor: 'packages' stamp: 'ls 1/16/2005 14:07'!
packagesNamed: name
	^self packages select: [ :p | p name = name ].
	! !

!UUniverse methodsFor: 'packages' stamp: 'ls 1/16/2005 14:06'!
removePackageNamed: packageName withVersion: version
	| packagesToRemove |
	packagesToRemove _ self packages select: [ :p | p name = packageName and: [ p version = version ] ].
	packagesToRemove do: [ :p | self removePackage: p ].
	! !

!UUniverse methodsFor: 'accessing' stamp: 'ls 2/13/2005 14:46'!
shortName
	"A short, computer-friendly alphanumeric identifier"

	^shortName! !

!UUniverse methodsFor: 'initialize-release' stamp: 'ls 2/13/2005 11:10'!
shortName: aString
	shortName _ aString
! !

!UUniverse methodsFor: 'accessing' stamp: 'ls 2/15/2005 21:49'!
standardUniverses
	"return a list of standard universes within the receiver.  See class UStandardUniverse"
	^self subclassResponsibility! !

!UUniverse methodsFor: 'packages' stamp: 'ls 2/13/2005 14:56'!
updatePackagesViaWWW
	"update the packages in this universe by downloading them from the universe's URL"
	^self subclassResponsibility! !

Model subclass: #UUniverseBrowser
	instanceVariableNames: 'universe configuration selectedPackageIndex packagesToInstall'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Browser'!

!UUniverseBrowser commentStamp: '<historical>' prior: 0!
A tool to support one-click installs and upgrades of packages within a universe.!

!UUniverseBrowser class methodsFor: 'instance creation' stamp: 'ls 2/13/2005 14:53'!
forUniverse: aUniverse
	^self new universe: aUniverse; yourself! !

!UUniverseBrowser class methodsFor: 'class initialization' stamp: 'ls 9/4/2004 14:29'!
initialize
	TheWorldMenu registerOpenCommand: {'Universe Browser'. {self. #open}}.
	Preferences setWindowColorFor: self name to: (Color r: 0.194 g: 0.645 b: 1.0).! !

!UUniverseBrowser class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 18:15'!
open
	^self new open! !

!UUniverseBrowser class methodsFor: 'dependencies' stamp: 'ls 7/29/2004 15:16'!
orderPackagesByDependency: packages
	"return a collection of the specified packages such that, when possible, any dependencies of a package are ordered before that package"
	"The present algorithm is simple but slow..."
	| remainingPackages orderedPackages packagesToAdd |
	remainingPackages _ Set new.
	orderedPackages _ OrderedCollection new.
	remainingPackages addAll: packages.
	
	"each time through this loop, add to orderedPackages any packages whose dependencies are not in remainaingPackages"
	[	packagesToAdd := remainingPackages select: [ :p | p depends noneSatisfy: [ :depName | remainingPackages anySatisfy: [ :p2 | p2 name = depName ] ] ].
		packagesToAdd isEmpty not
	] whileTrue: [
		orderedPackages addAll: packagesToAdd.
		remainingPackages := remainingPackages difference: packagesToAdd ].
	
	orderedPackages addAll: remainingPackages.
	^orderedPackages
! !

!UUniverseBrowser class methodsFor: 'class initialization' stamp: 'ls 7/29/2004 18:15'!
unload
	TheWorldMenu unregisterOpenCommand: 'Universe Browser'! !

!UUniverseBrowser methodsFor: 'install selections' stamp: 'ls 7/29/2004 17:31'!
allPackagesNeededToInstall: initialPackage  orIfImpossible: errorBlock
	"find all packages needed to installed initialPackage; if it is impossible to accomplish, invoke errorBlock with the name of the missing package"
	| newPackages packagesToConsider |
	newPackages _ Set new.
	packagesToConsider _ OrderedCollection with: initialPackage.
	[ packagesToConsider isEmpty ] whileFalse: [
		| package |
		package _ packagesToConsider removeFirst.
		(newPackages includes: package) ifFalse: [
			newPackages add: package.
			package depends do: [ :depName |
				((configuration includesPackageNamed: depName) not and: [ packagesToInstall noneSatisfy: [ :p | p name = depName  ] ])
				ifTrue: [
					"the dependency is needed but is not installed or planned to be installed"
					(universe hasPackageNamed: depName) ifTrue: [
						"in principle, one could additionally consider trying a different package than the newest..."
						packagesToConsider add: (universe newestPackageNamed: depName) ]
					ifFalse: [
						^errorBlock value: depName ] ] ] ] ].
	
	^newPackages! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 7/27/2004 21:34'!
anyPackageSelected
	^selectedPackageIndex > 0! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 9/4/2004 14:36'!
anyPackagesToInstall
	^packagesToInstall isEmpty not! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 9/4/2004 14:16'!
canMarkSelectionForInstallation
	^self anyPackageSelected and: [ (packagesToInstall includes: self selectedPackage) not ]! !

!UUniverseBrowser methodsFor: 'install selections' stamp: 'ls 7/28/2004 10:27'!
chooseUpgrades
	"select packages that appear to be upgrades of packages that are already installed"
	universe packageNames do: [ :name |
		(configuration includesPackageNamed: name) ifTrue: [
			| cpack mypack |
			cpack _ configuration packageNamed: name.
			mypack _ universe newestPackageNamed: name.
			mypack version > cpack version ifTrue: [
				self planToInstallPackageWithoutUIUpdate: mypack ] ] ].
	
	self changed: #packageDescriptions.! !

!UUniverseBrowser methodsFor: 'initialize-release' stamp: 'ls 7/27/2004 21:58'!
configuration: aConfiguration
	configuration _ aConfiguration! !

!UUniverseBrowser methodsFor: 'install selections' stamp: 'ls 9/4/2004 14:19'!
doInstall
	| orderedPackages |
	packagesToInstall isEmpty ifTrue: [
		^self inform: 'no packages selected to install' ].
		
	orderedPackages := UUniverseBrowser orderPackagesByDependency: packagesToInstall.
	orderedPackages do: [ :p | 
		Utilities informUser: 'installing ', p printString during: [
			configuration installPackage: p ] ].
	packagesToInstall _ Set new.
	self changed: #packageDescriptions.! !

!UUniverseBrowser methodsFor: 'initialize-release' stamp: 'ls 7/30/2004 15:05'!
initialize
	configuration _ UConfiguration forSystem.
	selectedPackageIndex _ 0.
	packagesToInstall _ Set new.
	self universe: UUniverse systemUniverse.
! !

!UUniverseBrowser methodsFor: 'install selections' stamp: 'ls 7/29/2004 17:11'!
installSelectedPackage
	self anyPackageSelected ifFalse: [ ^self ].
	self planToInstallPackage: self selectedPackage.
	
	! !

!UUniverseBrowser methodsFor: 'user interface' stamp: 'ls 9/4/2004 14:37'!
makeButtonWithAction: selector andGetState: getStateSelector andLabel: aString
	^(PluggableButtonMorph on: self getState: getStateSelector action: selector)
		label: aString;
		useRoundedCorners;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		onColor: self defaultBackgroundColor offColor: self defaultBackgroundColor muchLighter;
		yourself! !

!UUniverseBrowser methodsFor: 'user interface' stamp: 'ls 9/4/2004 14:35'!
makeButtonWithAction: selector  andLabel: aString
	^self makeButtonWithAction: selector andGetState: #returnTrue andLabel: aString! !

!UUniverseBrowser methodsFor: 'user interface' stamp: 'ls 2/13/2005 15:14'!
morphicView
	| win packageList installButton doInstallButton titleArea buttonList upgradeButton updateListButton descriptionArea installButtonHolder |
	win _ SystemWindow labelled: 'Universe'.
	win model: self.
	
	titleArea _ PluggableTextMorph on: self text: #titleAreaText accept: nil.
	titleArea hideScrollBarsIndefinitely.
	titleArea name: 'universe title'.
	win addMorph: titleArea frame: (0@0 extent: 1@0.1).
	
	packageList _ PluggableListMorph on: self list: #packageDescriptions  selected: #selectedPackageIndex changeSelected: #selectedPackageIndex: menu: nil.
	packageList name: 'package list'.
	win addMorph: packageList frame: ((0@0.1) extent: (0.5@0.8)).
	
	installButtonHolder _ Morph new.  "necessary to keep SystemWindow from screwing up the colors of the button"
	installButtonHolder 
		name: 'holder for install button';
		layoutPolicy: TableLayout new;
		borderColor: self defaultBackgroundColor.
	doInstallButton _ self makeButtonWithAction: #doInstall andGetState: #anyPackagesToInstall andLabel: 'Install Selections'.
	doInstallButton
		useSquareCorners;
		borderWidth: 0;
		setBalloonText: 'Download and install all the packages that you have selected';
		name: 'install selections button'.
	installButtonHolder addMorph: doInstallButton.
	win addMorph: installButtonHolder frame: ((0@0.9) extent:(1@0.1)).

	descriptionArea _ PluggableTextMorph on: self text: #selectedPackageDescription accept: nil.
	win addMorph: descriptionArea frame: ((0.5@0.4) extent: (0.5@0.5)).
	
	buttonList _ AlignmentMorph newColumn.
	buttonList
		cellInset: 0@3;
		name: 'button list'.
	win addMorph: buttonList frame: ((0.5@0.1) extent: (0.5@0.3)).
		
	installButton _ self makeButtonWithAction: #installSelectedPackage andGetState: #canMarkSelectionForInstallation andLabel: 'select package'.
	installButton setBalloonText: 'Select this package for installation'.
	buttonList addMorph: installButton.
	
	upgradeButton _ self makeButtonWithAction: #chooseUpgrades andLabel: 'select all upgrades'.
	upgradeButton setBalloonText: 'Select every possible upgrade for the currently installed packages'.
	buttonList addMorphBack: upgradeButton.
	
	updateListButton _ self makeButtonWithAction: #requestPackageList andLabel: 'update list from network'.
	updateListButton setBalloonText: 'Refresh the list of available packages from the network'.
	buttonList addMorphBack: updateListButton.
	
	^win! !

!UUniverseBrowser methodsFor: 'user interface' stamp: 'ls 7/29/2004 16:19'!
open
	self morphicView openInWorld! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 7/27/2004 22:02'!
packageDescriptions
	| commentary |
	^self sortedPackages collect: [ :p |
		commentary _ ''.
		(packagesToInstall includes: p) ifTrue: [ commentary _ ' (install)' ].
		(configuration installedPackages includes: p) ifTrue: [ commentary _ ' (installed)' ].
		
		p printString, commentary. ]! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 2/13/2005 15:12'!
packagesChanged
	packagesToInstall _ Set new.  "the selected packages may not be there any more!!"
	self selectedPackageIndex: 0.
	
	self changed: #packageDescriptions.
	! !

!UUniverseBrowser methodsFor: 'install selections' stamp: 'ls 7/29/2004 17:11'!
planToInstallPackage: package
	"plan to install a package plus its dependencies; refuses if any dependencies cannot be met"

	self planToInstallPackageWithoutUIUpdate: package.
	self changed: #packageDescriptions.
	! !

!UUniverseBrowser methodsFor: 'install selections' stamp: 'ls 7/29/2004 17:31'!
planToInstallPackageWithoutUIUpdate: initialPackage
	"same as planToInstallPackage:, but does not called #changed:.  Don't call this unless you later call #changed: yourself"
	| newPackages |
	"find all packages needed to install this one"
	newPackages _ self allPackagesNeededToInstall: initialPackage orIfImpossible: [ :missingDep |
		^self notify: 'could not find necessary package: ', missingDep ].
	
	packagesToInstall removeAllSuchThat: [ :p | p name = initialPackage name ].
	newPackages do: [ :p | packagesToInstall add: p ].
	! !

!UUniverseBrowser methodsFor: 'server communication' stamp: 'ls 2/15/2005 22:40'!
requestPackageList
universe addDependent: self.  "hack, to aid upgrading from Universes 0.5"
	Utilities informUser: 'updating package list...' during:  [
		universe updatePackagesViaWWW ]
! !

!UUniverseBrowser methodsFor: 'user interface' stamp: 'ls 9/4/2004 14:35'!
returnTrue
	"return true; used for buttons that are always enabled"
	^true! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 7/27/2004 21:33'!
selectedPackage
	^self sortedPackages at: self selectedPackageIndex! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 2/13/2005 18:05'!
selectedPackageDescription
	self anyPackageSelected ifFalse: [ ^ '' ].
	^String streamContents: [ :str |
		str nextPutAll: self selectedPackage description; cr; cr.
		self selectedPackage provides isEmpty ifFalse: [
			str nextPutAll: 'Provides:'; cr.
			self selectedPackage provides do: [ :depName |
				str tab; nextPutAll: depName; cr ].
			str cr].
		self selectedPackage depends isEmpty ifFalse: [
			str nextPutAll: 'Depends on:'; cr.
			self selectedPackage depends do: [ :depName |
				str tab; nextPutAll: depName; cr ].
			str cr].
		self selectedPackage conflicts isEmpty ifFalse: [
			str nextPutAll: 'Conflicts with:'; cr.
			self selectedPackage conflicts do: [ :depName |
				str tab; nextPutAll: depName; cr ].
			str cr].

		str nextPutAll: ('Maintained by: ', self selectedPackage maintainer); cr.
		str nextPutAll: ('Downloads from: ', self selectedPackage url toText); cr.
		self selectedPackage homepage ifNotNil: [
			str nextPutAll: ('Homepage: ', self selectedPackage homepage toText); cr]. ].
	! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 7/27/2004 21:26'!
selectedPackageIndex
	^selectedPackageIndex! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 9/4/2004 14:35'!
selectedPackageIndex: anInteger
	selectedPackageIndex _ anInteger.
	self changed: #selectedPackageIndex.
	self changed: #selectedPackageDescription.
	self changed: #canMarkSelectionForInstallation.! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 7/27/2004 21:31'!
sortedPackages
	^universe packages asSortedCollection: [ :p1 :p2 |
		p1 name < p2 name or: [
			p1 name = p2 name and: [ p1 version < p2 version ] ] ].
	! !

!UUniverseBrowser methodsFor: 'title pane' stamp: 'ls 7/29/2004 16:18'!
titleAreaText
	^universe description! !

!UUniverseBrowser methodsFor: 'initialize-release' stamp: 'ls 2/13/2005 15:12'!
universe: aUniverse
	universe _ aUniverse.
	universe addDependent: self.! !

!UUniverseBrowser methodsFor: 'package list' stamp: 'ls 2/13/2005 15:12'!
update: aSymbol
	aSymbol = #packages ifTrue: [ self packagesChanged ]! !

!String methodsFor: '*universes-model' stamp: 'ls 7/27/2004 17:32'!
uversionEqual: anObject
	^anObject isString and: [ self = anObject ]! !

!String methodsFor: '*universes-model' stamp: 'ls 7/27/2004 21:13'!
uversionLessThan: anObject
	^anObject isInteger or: [ self < anObject ]! !

!Integer methodsFor: '*universes-model' stamp: 'ls 7/27/2004 17:33'!
uversionEqual: anObject
	^anObject isInteger and: [ self = anObject ]! !

!Integer methodsFor: '*universes-model' stamp: 'ls 7/27/2004 17:33'!
uversionLessThan: anObject
	^anObject isInteger and: [ self < anObject ]! !

Magnitude subclass: #UVersion
	instanceVariableNames: 'components'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Model'!

!UVersion commentStamp: '<historical>' prior: 0!
A relatively simple hierarchical version number.!

!UVersion class methodsFor: 'instance creation' stamp: 'ls 7/27/2004 17:24'!
fromComponents: components
	^self basicNew components: components; yourself! !

!UVersion class methodsFor: 'instance creation' stamp: 'ls 7/27/2004 17:27'!
readFrom: stream
	| components |
	components _ OrderedCollection new.
	[ stream atEnd ] whileFalse: [
		stream peek isDigit ifTrue: [
			components add: (Integer readFrom: stream) ]
		ifFalse: [
			components add: (String streamContents: [ :compStr |
				[ stream atEnd not and: [ stream peek isDigit not ] ] whileTrue: [
					compStr nextPut: stream next ] ]) ] ].
		
	^self fromComponents: components! !

!UVersion methodsFor: 'comparing' stamp: 'ls 7/27/2004 21:15'!
< aVersion
	| numToCompare |
	numToCompare := components size min: aVersion components size.
	(components first: numToCompare) with: (aVersion components first: numToCompare) do: [ :myComp :itsComp |
		(myComp uversionLessThan: itsComp) ifTrue: [
			^true ].
		(itsComp uversionLessThan: myComp) ifTrue: [
			^false ] ].
	
	^components size < aVersion components size! !

!UVersion methodsFor: 'comparing' stamp: 'ls 7/27/2004 17:31'!
= aVersion
	components size = aVersion components size ifFalse:[ ^false ].

	components with: aVersion components do: [ :myComp :itsComp |
		(myComp uversionEqual: itsComp) ifFalse: [
			^false ] ].
	
	^true! !

!UVersion methodsFor: 'attributes' stamp: 'ls 7/27/2004 17:33'!
components
	^components! !

!UVersion methodsFor: 'initialization' stamp: 'ls 7/27/2004 17:27'!
components: aCollection
	components _ aCollection! !

!UVersion methodsFor: 'comparing' stamp: 'ls 7/28/2004 10:02'!
hash
	^components inject: 1 into: [ :tally :new |
		(tally bitXor: new hash) hashMultiply ]! !

!UVersion methodsFor: 'printing' stamp: 'ls 7/27/2004 17:28'!
printOn: aStream
	components do: [ :comp | aStream nextPutAll: comp asString ].! !

!StringSocket class methodsFor: '*universes' stamp: 'ls 8/3/2004 18:04'!
decodeStringArray: aString
	| idx numStrings |
	idx _ 1.
	numStrings _ aString getInteger32: idx.
	idx _ idx + 4.
	numStrings < 0 ifTrue: [ ^self error: 'invalid string socket encoding' ].
	numStrings > 10000000 ifTrue: [ self error: 'refusing to decode humongous string socket' ].
	
	^(1 to: numStrings) collect: [ :ignored |
		| size str |
		size _ aString getInteger32: idx.
		idx _ idx + 4.
		str _ aString copyFrom: idx to: idx+size-1.
		idx _ idx + size.
		str ]
	! !

!StringSocket class methodsFor: '*universes' stamp: 'ls 8/2/2004 16:18'!
encodeStringArray: stringArray
	| size outBuf outBufIndex |
	size _ self spaceToEncode: stringArray.
	
	outBuf _ String new: size.
	outBufIndex _ 1.

	outBuf putInteger32: stringArray size at: outBufIndex.
	outBufIndex _ outBufIndex + 4.
	stringArray do: [ :each |
		outBuf putInteger32: each size at: outBufIndex.
		outBufIndex _ outBufIndex + 4.
		outBuf 
			replaceFrom: outBufIndex 
			to: outBufIndex + each size - 1 
			with: each 
			startingAt: 1.
		outBufIndex _ outBufIndex + each size.
	].
	
	^outBuf! !

!StringSocket class methodsFor: '*universes' stamp: 'ls 8/2/2004 16:18'!
spaceToEncode: stringArray
	^stringArray inject: 4 into: [ :sum :array |
		sum + (array size + 4) ].! !

Object subclass: #UAccount
	instanceVariableNames: 'username password email packageNames'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Policy'!

!UAccount commentStamp: '<historical>' prior: 0!
An account as used in the standard UPolicy's.!

!UAccount methodsFor: 'packages' stamp: 'ls 7/28/2004 18:03'!
addPackageName: name
	packageNames add: name! !

!UAccount methodsFor: 'accessing' stamp: 'ls 7/28/2004 21:47'!
email: aString
	email _ aString! !

!UAccount methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 18:02'!
initialize
	username _ 'joeblow'.
	password _ ''.
	packageNames _ Set new.! !

!UAccount methodsFor: 'packages' stamp: 'ls 7/28/2004 18:03'!
ownsPackageName: name
	^packageNames includes: name! !

!UAccount methodsFor: 'accessing' stamp: 'ls 7/28/2004 21:50'!
password
	^password! !

!UAccount methodsFor: 'accessing' stamp: 'ls 7/28/2004 21:47'!
password: anObject
	password _ anObject! !

!UAccount methodsFor: 'printing' stamp: 'ls 2/15/2005 23:44'!
printOn: aStream
	aStream nextPutAll: 'Account: ', username! !

!UAccount methodsFor: 'accessing' stamp: 'ls 7/28/2004 21:50'!
username
	^username! !

!UAccount methodsFor: 'accessing' stamp: 'ls 7/28/2004 21:47'!
username: anObject
	username _ anObject! !

Object subclass: #UConfiguration
	instanceVariableNames: 'installedPackages'
	classVariableNames: 'SystemConfiguration'
	poolDictionaries: ''
	category: 'Universes-Model'!

!UConfiguration commentStamp: '<historical>' prior: 0!
One configuration of packages.!

!UConfiguration class methodsFor: 'system' stamp: 'ls 7/27/2004 21:57'!
forSystem
	"return a configuration describing the currently running system"
	^SystemConfiguration ifNil: [ SystemConfiguration _ self new ].
	! !

!UConfiguration methodsFor: 'packages' stamp: 'ls 7/28/2004 10:19'!
includesPackageNamed: name
	^self installedPackages anySatisfy: [ :p | p name = name ]! !

!UConfiguration methodsFor: 'initialize-release' stamp: 'ls 7/27/2004 21:55'!
initialize
	installedPackages _ Set new.! !

!UConfiguration methodsFor: 'installing' stamp: 'ls 7/27/2004 21:55'!
installPackage: aPackage
	| matchingPackages |
	matchingPackages _ installedPackages select: [ :p | p name = aPackage name ].
	installedPackages removeAll: matchingPackages.
	aPackage install.
	installedPackages add: aPackage.
	! !

!UConfiguration methodsFor: 'packages' stamp: 'ls 7/27/2004 22:02'!
installedPackages
	^installedPackages! !

!UConfiguration methodsFor: 'packages' stamp: 'ls 7/28/2004 10:18'!
packageNamed: name
	^self installedPackages detect: [ :p | p name = name ]! !

Object subclass: #UInstaller
	instanceVariableNames: ''
	classVariableNames: 'Installers'
	poolDictionaries: ''
	category: 'Universes-Installers'!

!UInstaller commentStamp: '<historical>' prior: 0!
A simply hierarchy for loading Squeak content in various formats.!

UInstaller subclass: #UIFileOut
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Installers'!

!UIFileOut methodsFor: 'testing' stamp: 'ls 9/4/2004 14:02'!
handlesFilename: filename
	^#('.cs' '.st' '.st.gz' '.cs.gz') anySatisfy: [ :ending | filename endsWith: ending ]! !

!UIFileOut methodsFor: 'installing' stamp: 'ls 7/29/2004 20:01'!
install: inStream  usingBaseName: basename
	"find a changeset name that is not used"
	| num changesetName stream |
	num _ 0.
	[  	changesetName _ basename.
	   	num > 0 ifTrue:[ changesetName _ changesetName, '-', num printString. ].
		(ChangeSorter changeSetNamed: changesetName) notNil ]
	whileTrue: [ num _ num + 1 ].
	
	"decompress if necessary"
	inStream peek asInteger = 16r1F
		ifTrue: [ stream _ ReadStream on: ((GZipReadStream on: inStream) upToEnd) asString ]
		ifFalse: [ stream _ inStream ].
		
	ChangeSorter newChangesFromStream: stream named: changesetName! !

UInstaller subclass: #UIMonticello
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Installers'!

!UIMonticello methodsFor: 'testing' stamp: 'ls 7/29/2004 11:04'!
handlesFileEnding: ending
	^#('mcz') includes: ending! !

!UIMonticello methodsFor: 'installing' stamp: 'ls 7/29/2004 19:26'!
installFileNamed: filename
	Smalltalk at: #MCMczReader ifPresent: [ :reader |
		^reader loadVersionFile: filename ].
	MczInstaller installFileNamed: filename! !

UInstaller subclass: #UIMpeg
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Installers'!

!UIMpeg methodsFor: 'testing' stamp: 'ls 7/29/2004 11:04'!
handlesFileEnding: ending
	^#('mpg' 'mpeg') includes: ending! !

!UIMpeg methodsFor: 'installing' stamp: 'ls 7/29/2004 11:39'!
install: stream usingBasename: basename
	| movieDir movieFile |
	movieDir := FileDirectory default directoryNamed: 'movies'.
	movieDir assureExistence.
	
	movieDir removeFileNamed: basename.
	
	movieFile _ movieDir newFileNamed: basename, '.mpeg'.
	stream binary.  movieFile binary.
	movieFile nextPutAll: stream upToEnd.
	movieFile close.
	
	Smalltalk at: #MPEGMoviePlayerMorph ifPresent: [ :player |
		player playFile: (movieDir fullNameFor: basename, '.mpeg') ]! !

UInstaller subclass: #UIProject
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Installers'!

!UIProject methodsFor: 'testing' stamp: 'ls 7/29/2004 11:05'!
handlesFileEnding: ending
	^#('pr') includes: ending! !

!UIProject methodsFor: 'installing' stamp: 'ls 9/18/2004 18:18'!
installFileNamed: filename
	FileDirectory splitName: filename to: [ :path :base |
		[ 	
			ProjectViewMorph openFromDirectory: (FileDirectory on: path) andFileName: base
		] on: ProjectEntryNotification do:
		[ :ex |
			"don't enter it" ] ]! !

UInstaller subclass: #UISar
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Installers'!

!UISar methodsFor: 'testing' stamp: 'ls 7/29/2004 11:04'!
handlesFileEnding: ending
	^#('sar') includes: ending! !

!UISar methodsFor: 'installing' stamp: 'ls 7/29/2004 11:44'!
installFileNamed: filename
	SARInstaller installSAR: filename! !

!UInstaller class methodsFor: 'initialization' stamp: 'ls 7/29/2004 11:09'!
initialize
	Installers ifNil: [ Installers _ Set new ].
	
	{UIFileOut. UIMonticello. UIMpeg. UIProject. UISar} do: [ :c |
		self registerInstaller: c new ]! !

!UInstaller class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 11:10'!
installFileNamed: filename
	(self installerForFilename: filename) installFileNamed: filename! !

!UInstaller class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 11:10'!
installerForFilename: filename
	^self registeredInstallers detect: [ :i | i handlesFilename: filename ] ifNone: [ self error: 'no installer handles file ', filename ].! !

!UInstaller class methodsFor: 'registry' stamp: 'ls 7/29/2004 11:02'!
registerInstaller: installer
	Installers add: installer! !

!UInstaller class methodsFor: 'registry' stamp: 'ls 7/29/2004 11:11'!
registeredInstallers
	^Installers asArray! !

!UInstaller methodsFor: 'comparing' stamp: 'ls 7/29/2004 11:02'!
= anInstaller
	^self class = anInstaller class! !

!UInstaller methodsFor: 'testing' stamp: 'ls 7/29/2004 10:59'!
handlesFileEnding: anEnding
	^false! !

!UInstaller methodsFor: 'testing' stamp: 'ls 7/29/2004 11:08'!
handlesFilename: filename
	^self handlesFileEnding: (FileDirectory extensionFor: filename)
	! !

!UInstaller methodsFor: 'comparing' stamp: 'ls 7/29/2004 11:03'!
hash
	^self class hash! !

!UInstaller methodsFor: 'installing' stamp: 'ls 7/29/2004 11:06'!
install: stream  usingBaseName: baseName
	self subclassResponsibility! !

!UInstaller methodsFor: 'installing' stamp: 'ls 9/4/2004 15:02'!
installFileNamed: filename
	| stream baseName |
	stream _ (FileStream readOnlyFileNamed: filename).
	baseName _ (FileDirectory splitName: filename to: [:path :base|base]) copyUpTo: $. .

	self install: stream usingBaseName: baseName.
	stream close.
	! !

Object subclass: #UInterfaceUtilities
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Interface'!

!UInterfaceUtilities commentStamp: 'ls 2/13/2005 17:22' prior: 0!
This class holds miscellaneous bits of code used to build user interfaces in the various Universes tools.
!

!UInterfaceUtilities class methodsFor: 'as yet unclassified' stamp: 'ls 2/13/2005 17:37'!
makeButtonWithAction: selector andGetState: getStateSelector andLabel: aString for: model
	^(PluggableButtonMorph on: model getState: getStateSelector action: selector)
		label: aString;
		useRoundedCorners;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		onColor: model defaultBackgroundColor offColor: model defaultBackgroundColor muchLighter;
		yourself! !

!UInterfaceUtilities class methodsFor: 'as yet unclassified' stamp: 'ls 2/13/2005 17:41'!
makeButtonWithAction: selector  andLabel: aString for: model
	^self makeButtonWithAction: selector andGetState: #returnTrue  andLabel: aString	for: model! !

!UInterfaceUtilities class methodsFor: 'as yet unclassified' stamp: 'ls 2/13/2005 17:34'!
makeFieldGet: getSelector  set: setSelector  for: model
	| field fieldHeight |
	fieldHeight _ TextStyle default defaultFont pointSize + 8.
		
		
	field := PluggableTextMorph on: model text: getSelector accept: setSelector.
	field height: fieldHeight.
	field hResizing: #spaceFill.
	field hideScrollBarsIndefinitely.
	field setProperty: #alwaysAccept toValue: true.

	model noteField: field.

	^field! !

!UInterfaceUtilities class methodsFor: 'as yet unclassified' stamp: 'ls 2/13/2005 17:42'!
makeFieldRowNamed: fieldName  getSelector: getSelector setSelector: setSelector for: model
	^self makeFieldRowNamed: fieldName  getSelector: getSelector setSelector: setSelector isPassword: false for: model! !

!UInterfaceUtilities class methodsFor: 'as yet unclassified' stamp: 'ls 2/13/2005 17:36'!
makeFieldRowNamed: fieldName  getSelector: getSelector setSelector: setSelector isPassword: isPassword for: model
	| row field |
	row _ AlignmentMorph newRow.
	row color: Color transparent.
	row cellInset: 3@0.
	
	field _ self makeFieldGet: getSelector set: setSelector for: model.
	isPassword ifTrue:[
		field font: (StrikeFont passwordFontSize: TextStyle default defaultFont pointSize) ].

	row addMorph: (StringMorph contents: fieldName).
	row addMorphBack: field.

	^row

! !

Object subclass: #UMessage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

!UMessage commentStamp: '<historical>' prior: 0!
A message that can be sent to or from a UServer.  All instances may be converted to an array of strings, and that array of strings may be parsed back with fromStringArray:.!

UMessage subclass: #UMAddAccount
	instanceVariableNames: 'username password email'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

!UMAddAccount commentStamp: '<historical>' prior: 0!
A request to add a user account.
!

!UMAddAccount class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 14:34'!
fromStringArray: stringArray
	^self username: stringArray second password: stringArray third email: stringArray fourth! !

!UMAddAccount class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 14:34'!
username: username  password: password  email: email
	^self basicNew username: username  password: password  email: email! !

!UMAddAccount methodsFor: '*universes-server' stamp: 'ls 7/28/2004 21:46'!
applyToServer: server forConnection: connection
	server connection: connection requestedAccountWithUsername: username password: password email: email! !

!UMAddAccount methodsFor: 'converting' stamp: 'ls 7/28/2004 14:34'!
asStringArray
	^{'addaccount' . username . password . email}! !

!UMAddAccount methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 14:33'!
username: username0  password: password0  email: email0
	username _ username0.
	password _ password0.
	email _ email0.
	! !

UMessage subclass: #UMAddPackage
	instanceVariableNames: 'username password package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

!UMAddPackage class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 17:07'!
fromStringArray: array
	^self username: array second password: array third package: (UPackage decodeFromStringStream: (ReadStream on: (array allButFirst: 3)))! !

!UMAddPackage class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 14:37'!
username: username password: password package: package
	^self basicNew username: username password: password package: package! !

!UMAddPackage methodsFor: '*universes-server' stamp: 'ls 7/28/2004 17:03'!
applyToServer: server forConnection: connection
	server connection: connection requestedForUsername: username andPassword: password toAddPackage: package! !

!UMAddPackage methodsFor: 'converting' stamp: 'ls 7/28/2004 16:56'!
asStringArray
	^{'addpackage' . username . password },
	  package stringArrayEncoding! !

!UMAddPackage methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 14:37'!
username: username0 password: password0 package: package0
	username _ username0.
	password _ password0.
	package _ package0.
	! !

UMessage subclass: #UMEditAccount
	instanceVariableNames: 'username password newPassword newEmail'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

!UMEditAccount commentStamp: '<historical>' prior: 0!
A request to change the password or email of an account.
!

!UMEditAccount class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 14:38'!
fromStringArray: array
	^self username: array second password: array third newPassword: array fourth newEmail: array fifth! !

!UMEditAccount class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 14:36'!
username: username  password: password  newPassword: newPassword newEmail: newEmail
	^self basicNew username: username  password: password  newPassword: newPassword newEmail: newEmail! !

!UMEditAccount methodsFor: '*universes-server' stamp: 'ls 7/28/2004 17:55'!
applyToServer: server forConnection: connection
	server connection: connection requestedAccountChangeForUsername: username password: password newPassword: newPassword newEmail: newEmail! !

!UMEditAccount methodsFor: 'converting' stamp: 'ls 7/28/2004 14:36'!
asStringArray
	^{'editaccount' . username . password . newPassword . newEmail}! !

!UMEditAccount methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 14:36'!
username: username0  password: password0  newPassword: newPassword0 newEmail: newEmail0
	username _ username0.
	password _ password0.
	newPassword _ newPassword0.
	newEmail _ newEmail0.
	! !

UMessage subclass: #UMEditedAccount
	instanceVariableNames: 'username newPassword newEmail'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

!UMEditedAccount commentStamp: '<historical>' prior: 0!
Notification that an account has been successfully edited.!

!UMEditedAccount class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 17:38'!
fromStringArray: array
	^self username: array second newPassword: array third newEmail: array fourth! !

!UMEditedAccount class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 17:37'!
username: username  newPassword: newPassword  newEmail: newEmail
	^self basicNew
		username: username  newPassword: newPassword  newEmail: newEmail;
		yourself! !

!UMEditedAccount methodsFor: '*universes-editor' stamp: 'ls 7/28/2004 17:59'!
applyToEditor: editor
	editor accountUpdatedWithUsername: username  password:  newPassword  email: newEmail! !

!UMEditedAccount methodsFor: 'converting' stamp: 'ls 7/28/2004 17:37'!
asStringArray
	^{'editedaccount' . username . newPassword . newEmail }! !

!UMEditedAccount methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 17:36'!
username: username0  newPassword: newPassword0  newEmail: newEmail0
	username _ username0.
	newPassword _ newPassword0.
	newEmail _ newEmail0.
	! !

UMessage subclass: #UMError
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

!UMError commentStamp: '<historical>' prior: 0!
An error message from the server to the client.!

UMError subclass: #UMConnectionFailed
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

!UMConnectionFailed commentStamp: '<historical>' prior: 0!
An error in establishing a connection to a server.!

!UMError class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 13:33'!
description: aString
	^self basicNew
		description: aString;
		yourself! !

!UMError class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 17:02'!
fromStringArray: array
	^self description: array second! !

!UMError methodsFor: '*universes-editor' stamp: 'ls 7/28/2004 21:58'!
applyToEditor: editor
	"the inform: is deferred, because otherwise the editor can stop stepping!!"
	WorldState addDeferredUIMessage: [ editor inform: 'Error: ', description ]
! !

!UMError methodsFor: '*universes-server' stamp: 'ls 7/28/2004 13:35'!
applyToServer: server forConnection: connection
	"if the client sends an error back, then the connection is really messed up"
	server destroyConnection: connection
	! !

!UMError methodsFor: 'converting' stamp: 'ls 7/28/2004 13:36'!
asStringArray
	^{'error' . description }! !

!UMError methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 13:26'!
description: aString
	description := aString! !

UMessage subclass: #UMMalformed
	instanceVariableNames: 'stringArray'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

!UMMalformed commentStamp: '<historical>' prior: 0!
a malformed packet!

!UMMalformed class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 11:30'!
fromStringArray: array
	^self basicNew stringArray: array; yourself! !

!UMMalformed methodsFor: 'converting' stamp: 'ls 7/28/2004 11:31'!
asStringArray
	^self error: 'a malformed packet cannot be converted to a string array'! !

!UMMalformed methodsFor: 'accessing' stamp: 'ls 7/28/2004 11:45'!
stringArray: anObject
	stringArray _ anObject! !

UMessage subclass: #UMPackageAdded
	instanceVariableNames: 'package'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

!UMPackageAdded commentStamp: 'ls 7/28/2004 15:08' prior: 0!
A message declaring that a package has been added to the universe.
!

!UMPackageAdded class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 15:07'!
fromStringArray: array
	| str |
	str _ ReadStream on: array.
	str next.
	^self package: (UPackage decodeFromStringStream: str)! !

!UMPackageAdded class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 15:07'!
package: aPackage
	^self basicNew
		package: aPackage;
		yourself! !

!UMPackageAdded methodsFor: '*universes-client' stamp: 'ls 7/30/2004 15:01'!
applyToClient: aClient
	aClient packageAdded: package! !

!UMPackageAdded methodsFor: '*universes-editor' stamp: 'ls 7/30/2004 15:38'!
applyToEditor: editor
	editor closeEditorForPackage: package.
! !

!UMPackageAdded methodsFor: 'converting' stamp: 'ls 7/28/2004 15:07'!
asStringArray
	^#('packageadded'), package stringArrayEncoding! !

!UMPackageAdded methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 14:59'!
package: aPackage
	package _ aPackage! !

UMessage subclass: #UMPackageList
	instanceVariableNames: 'packages'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

!UMPackageList commentStamp: '<historical>' prior: 0!
A message describing a list of packages that are in the server's universe.!

!UMPackageList class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 15:05'!
fromStringArray: array
	| str packages numPackages |
	str _ ReadStream on: array.
	str next.  "skip the 'packages' designation".

	packages _ OrderedCollection new.

	numPackages _ Integer readFromString: str next.
	numPackages timesRepeat: [
		packages add: (UPackage decodeFromStringStream: str) ].
		
	^self packages: packages! !

!UMPackageList class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 12:01'!
packages: aCollection
	^self basicNew
		packages: aCollection;
		yourself! !

!UMPackageList methodsFor: '*universes-client' stamp: 'ls 7/30/2004 15:01'!
applyToClient: aClient
	aClient newPackageList: packages! !

!UMPackageList methodsFor: 'converting' stamp: 'ls 7/28/2004 15:04'!
asStringArray
	^Array streamContents: [ :str |
		str nextPut: 'packages'.
		str nextPut: packages size printString.
		packages do: [ :pack |
			str nextPutAll: pack stringArrayEncoding ]. ].! !

!UMPackageList methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 12:01'!
packages: aCollection
	packages _ aCollection! !

UMessage subclass: #UMPackageRemoved
	instanceVariableNames: 'packageName version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

!UMPackageRemoved commentStamp: '<historical>' prior: 0!
A message claiming that a package has been removed.!

!UMPackageRemoved class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 14:58'!
fromStringArray: array
	^self packageName: array second version: (UVersion readFromString: array third)! !

!UMPackageRemoved class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 14:58'!
packageName: aString version: aVersion
	^self basicNew
		packageName: aString version: aVersion;
		yourself! !

!UMPackageRemoved methodsFor: '*universes-client' stamp: 'ls 7/30/2004 15:02'!
applyToClient: aClient
	aClient removedPackageNamed: packageName  withVersion: version! !

!UMPackageRemoved methodsFor: 'converting' stamp: 'ls 7/28/2004 14:57'!
asStringArray
	^{'packageremoved' . packageName . version printString }! !

!UMPackageRemoved methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 14:57'!
packageName: aString  version: aVersion
	packageName _ aString.
	version _ aVersion.! !

UMessage subclass: #UMProtocolVersion
	instanceVariableNames: 'version'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

!UMProtocolVersion commentStamp: '<historical>' prior: 0!
Tell the receiver what protocol version the sender understands.  The receiver should not send messages back which use a newer protocol version.
!

!UMProtocolVersion class methodsFor: 'instance creation' stamp: 'ls 2/15/2005 21:40'!
fromStringArray: array
	^self version: (Integer readFromString: array second)! !

!UMProtocolVersion class methodsFor: 'instance creation' stamp: 'ls 2/15/2005 21:40'!
version: anInteger
	^self new version: anInteger; yourself! !

!UMProtocolVersion methodsFor: 'applying' stamp: 'ls 2/15/2005 21:41'!
applyToClient: client! !

!UMProtocolVersion methodsFor: 'applying' stamp: 'ls 2/15/2005 21:42'!
applyToEditor: editor! !

!UMProtocolVersion methodsFor: 'applying' stamp: 'ls 2/15/2005 21:42'!
applyToMultiServer: server forConnection: connection! !

!UMProtocolVersion methodsFor: 'applying' stamp: 'ls 2/15/2005 21:41'!
applyToServer: server forConnection: connection! !

!UMProtocolVersion methodsFor: 'converting' stamp: 'ls 2/15/2005 21:41'!
asStringArray
	^{'protocolversion' . version asString}! !

!UMProtocolVersion methodsFor: 'attributes' stamp: 'ls 2/15/2005 21:40'!
version
	^version! !

!UMProtocolVersion methodsFor: 'initialize-release' stamp: 'ls 2/15/2005 21:39'!
version: anInteger
	version _ anInteger! !

UMessage subclass: #UMRemovePackage
	instanceVariableNames: 'username password packageName packageVersion'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

!UMRemovePackage commentStamp: '<historical>' prior: 0!
A request to remove a package from a universe.
!

!UMRemovePackage class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 17:26'!
fromStringArray: array
	^self username: array second password: array third packageName: array fourth packageVersion: (UVersion readFromString: array fifth)! !

!UMRemovePackage class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 14:41'!
username: username password: password packageName: packageName packageVersion: packageVersion
	^self basicNew username: username password: password packageName: packageName packageVersion: packageVersion! !

!UMRemovePackage methodsFor: '*universes-server' stamp: 'ls 7/28/2004 17:20'!
applyToServer: server forConnection: connection
	server connection: connection requestedForUsername: username andPassword: password toRemovePackageNamed: packageName withVersion: packageVersion! !

!UMRemovePackage methodsFor: 'converting' stamp: 'ls 7/29/2004 15:46'!
asStringArray
	^{'removepackage' . username . password . packageName . packageVersion printString }
! !

!UMRemovePackage methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 14:39'!
username: username0 password: password0 packageName: packageName0 packageVersion: packageVersion0
	username _ username0.
	password _ password0.
	packageName _ packageName0.
	packageVersion _ packageVersion0.
	! !

UMessage subclass: #UMRequestPackages
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

!UMRequestPackages commentStamp: '<historical>' prior: 0!
A package requesting that a copy of all packages in the server's universe.!

!UMRequestPackages class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 11:59'!
fromStringArray: array
	^self basicNew! !

!UMRequestPackages methodsFor: '*universes-server' stamp: 'ls 7/28/2004 13:08'!
applyToServer: server forConnection: connection
	connection nextPut: (UMPackageList packages: server universe packages) asStringArray
! !

!UMRequestPackages methodsFor: 'converting' stamp: 'ls 7/28/2004 11:59'!
asStringArray
	^#('requestpackages')! !

UMessage subclass: #UMSelectServer
	instanceVariableNames: 'shortName'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Messages'!

!UMSelectServer commentStamp: 'ls 2/13/2005 16:05' prior: 0!
A request to a multi-server, to select the server for a specific universe.  Subsequent messages should be directed to the selected universe instead of to the specific universes.!

!UMSelectServer class methodsFor: 'instance creation' stamp: 'ls 2/13/2005 16:06'!
fromStringArray: stringArray
	^self shortName: stringArray second! !

!UMSelectServer class methodsFor: 'instance creation' stamp: 'ls 2/13/2005 16:06'!
shortName: aString
	^self new
		shortName: aString;
		yourself! !

!UMSelectServer methodsFor: '*universes-server' stamp: 'ls 2/13/2005 16:18'!
applyToMultiServer: server forConnection: connection
	server switchConnection: connection toServerNamed: shortName! !

!UMSelectServer methodsFor: 'converting' stamp: 'ls 2/13/2005 16:06'!
asStringArray
	^{'selectserver' . shortName}! !

!UMSelectServer methodsFor: 'initialize-release' stamp: 'ls 2/13/2005 16:12'!
shortName: aString
	shortName _ aString! !

!UMessage class methodsFor: 'instance creation' stamp: 'ls 2/15/2005 21:41'!
fromStringArray: array
	| class |
	class _ nil.
	array first = 'requestpackages' ifTrue: [ class _ UMRequestPackages ].
	array first = 'packages' ifTrue: [ class _ UMPackageList ].
	array first = 'error' ifTrue: [ class _ UMError ].
	array first = 'addaccount' ifTrue: [ class _ UMAddAccount ].
	array first = 'addpackage' ifTrue: [ class _ UMAddPackage ].
	array first = 'editaccount' ifTrue: [ class _ UMEditAccount ].
	array first = 'editedaccount' ifTrue: [ class _ UMEditedAccount ].
	array first = 'packageadded' ifTrue: [ class _ UMPackageAdded ].
	array first = 'packageremoved' ifTrue: [ class _ UMPackageRemoved ].
	array first = 'removepackage' ifTrue: [ class _ UMRemovePackage ].
	array first = 'selectserver' ifTrue: [ class _ UMSelectServer ].
	array first = 'protocolversion' ifTrue: [ class _ UMProtocolVersion ].

	class ifNil: [
			^UMMalformed fromStringArray: array ].
	
	^[ class fromStringArray: array ] on: Error do: [ :ex | UMMalformed fromStringArray: array ]! !

!UMessage methodsFor: '*universes-client' stamp: 'ls 7/30/2004 15:00'!
applyToClient: aClient
	"apply this message to a UUniverseClient"
	! !

!UMessage methodsFor: '*universes-editor' stamp: 'ls 7/28/2004 15:40'!
applyToEditor: editor
	! !

!UMessage methodsFor: '*universes-server' stamp: 'ls 2/13/2005 16:18'!
applyToMultiServer: server  forConnection: connection
	connection nextPut: (UMError description: 'message inappropriate for multi-server') asStringArray! !

!UMessage methodsFor: '*universes-server' stamp: 'ls 7/28/2004 17:25'!
applyToServer: server  forConnection: connection
self inspect.
	connection nextPut: (UMError description: 'message inappropriate for server') asStringArray! !

!UMessage methodsFor: 'converting' stamp: 'ls 7/28/2004 11:30'!
asStringArray
	^self subclassResponsibility! !

Object subclass: #UOneShotConnection
	instanceVariableNames: 'inputMessage outputQueue hasBeenRead hasBeenWritten'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Server'!

!UOneShotConnection commentStamp: '<historical>' prior: 0!
A fake StringSocket used to integrate a UUniverseServer with an HTTP server.

A OneShotConnection has exactly one input message and only accepts one output message.  It puts the supplied output message onto a SharedQueue and then disconnects itself.
!

!UOneShotConnection class methodsFor: 'instance creation' stamp: 'ls 8/2/2004 16:31'!
withInMessage: inMessage0  andOutQueue: aSharedQueue
	^self basicNew
		initializeWithInMessage: inMessage0  andOutQueue: aSharedQueue;
		yourself! !

!UOneShotConnection methodsFor: 'string socket' stamp: 'ls 8/2/2004 16:33'!
destroy
	hasBeenWritten _ true! !

!UOneShotConnection methodsFor: 'initialize-release' stamp: 'ls 8/2/2004 16:33'!
initializeWithInMessage: inMessage0  andOutQueue: aSharedQueue
	inputMessage _ inMessage0.
	outputQueue _ aSharedQueue.
	hasBeenRead _ false.
	hasBeenWritten _ false.! !

!UOneShotConnection methodsFor: 'string socket' stamp: 'ls 8/2/2004 16:34'!
isConnected
	^hasBeenWritten not! !

!UOneShotConnection methodsFor: 'string socket' stamp: 'ls 8/2/2004 16:32'!
nextOrNil
	hasBeenRead ifTrue:[ ^nil ].
	hasBeenRead _ true.
	^inputMessage! !

!UOneShotConnection methodsFor: 'string socket' stamp: 'ls 8/2/2004 16:53'!
nextPut: anObject
	outputQueue nextPut: anObject.
	hasBeenWritten _ true! !

!UOneShotConnection methodsFor: 'string socket' stamp: 'ls 8/2/2004 16:32'!
processIO! !

Object subclass: #UPackage
	instanceVariableNames: 'name version description provides depends conflicts url homepage maintainer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Model'!

!UPackage commentStamp: 'ls 7/27/2004 21:20' prior: 0!
One release of one package.!

!UPackage class methodsFor: '*universes-messages' stamp: 'ls 2/13/2005 12:40'!
decodeFromStringStream: str
	| package numDepends homePageText numProvides numConflicts |
	package _ self new.
	package name: str next.
	package version: (UVersion readFromString: str next).
	package description: str next.
	package url: (Url absoluteFromText: str next).

	homePageText _ str next.
	package homepage: (homePageText isEmpty ifTrue: [ nil ] ifFalse: [ homePageText asUrl ]).

	package maintainer: str next.

	numProvides _ Integer readFromString: str next. 
	package provides: (str next: numProvides).
	numDepends _ Integer readFromString: str next. 
	package depends: (str next: numDepends).
	numConflicts _ Integer readFromString: str next. 
	package conflicts: (str next: numConflicts).

	^package
! !

!UPackage class methodsFor: 'decoding' stamp: 'ls 10/19/2006 10:32'!
decodeFromXMLElement: doc
	| package urlString |
	package _ self new.

	package name: (self getXMLPartNamed: 'name' from: doc).
	package version: (UVersion readFromString: (self getXMLPartNamed: 'version' from: doc)).
	package description: (self getXMLPartNamed: 'description' from: doc).
	urlString _ self getXMLPartNamed: 'url' from: doc.
	urlString isEmpty ifFalse: [
 	package url: (Url absoluteFromText: urlString). ].
	(doc elementAt: 'homepage') ifNotNil: [
		package homepage: (Url absoluteFromText: (self getXMLPartNamed: 'homepage' from: doc)) ].
	package maintainer: (self getXMLPartNamed: 'maintainer' from: doc).
	package provides: (self getXMLPackageList: 'provides' from: doc).
	package depends: (self getXMLPackageList: 'depends' from: doc).
	package conflicts: (self getXMLPackageList: 'conflicts' from: doc).

	^package! !

!UPackage class methodsFor: 'decoding' stamp: 'ls 2/13/2005 13:24'!
decodePackagesFromXMLStream: stream
	| doc |
	doc _ XMLDOMParser parseDocumentFrom: stream.
	^doc elements collect: [ :element | self decodeFromXMLElement: element ].
! !

!UPackage class methodsFor: 'decoding' stamp: 'ls 2/13/2005 13:12'!
getXMLPackageList: listname from: element
	| listElement |
	listElement _ element elementAt: listname.
	listElement ifNil: [ ^#() ].
	^listElement elements collect: [ :nameXML |
		nameXML contents first string ]
! !

!UPackage class methodsFor: 'decoding' stamp: 'ls 2/13/2005 15:05'!
getXMLPartNamed: partName  from: xmlDoc
	| element |
	element _ xmlDoc elementAt: partName.
	element contents isEmpty ifTrue:[ ^ '' ].
	^element contents first string! !

!UPackage class methodsFor: 'decoding' stamp: 'ls 2/13/2005 13:41'!
readPackageListFromFileNamed: filename
	| file packages |
	file _ FileStream readOnlyFileNamed: filename.
	packages _ self decodePackagesFromXMLStream: file.
	file close.
	^packages! !

!UPackage class methodsFor: 'saving' stamp: 'ls 2/13/2005 14:47'!
savePackageList: packageList  onFileNamed: filename
	| tmpName file |
	tmpName _ filename, 'tmp'.
	FileDirectory default deleteFileNamed: tmpName ifAbsent:  [].

	file _ FileStream fileNamed: tmpName.
	packageList do: [ :package |
		file nextPutAll: package xmlForExport ].
	file close.

	FileDirectory default rename: tmpName toBe: filename.
! !

!UPackage methodsFor: 'comparing' stamp: 'ls 10/20/2006 18:40'!
= anotherPackage
	self hash = anotherPackage hash ifFalse: [ ^false ].

	self name = anotherPackage name ifFalse: [ ^false ].
	self version = anotherPackage version ifFalse: [ ^false ].
	self depends = anotherPackage depends ifFalse: [ ^false ].
	self provides = anotherPackage provides ifFalse: [ ^false ].
	self conflicts = anotherPackage conflicts ifFalse: [ ^false ].
	self url = anotherPackage url ifFalse: [ ^false ].
	self maintainer = anotherPackage maintainer ifFalse: [ ^false ].
	self homepage isNil = anotherPackage homepage isNil ifFalse: [ ^false ].
	(self homepage isNil or: [ 
		self homepage toText = anotherPackage homepage toText]) ifFalse: [ ^false ].

	self description = anotherPackage description ifFalse:[ ^false ].

	^true
! !

!UPackage methodsFor: 'initialize-release' stamp: 'ls 7/27/2004 21:19'!
addDependency: aString
	depends add: aString! !

!UPackage methodsFor: 'accessing' stamp: 'ls 2/13/2005 12:28'!
conflicts
	^conflicts ifNil: [ Set new ]
! !

!UPackage methodsFor: 'initialize-release' stamp: 'ls 2/13/2005 12:27'!
conflicts: aCollection
	conflicts _ Set withAll: aCollection! !

!UPackage methodsFor: 'accessing' stamp: 'ls 7/28/2004 09:53'!
depends
	^depends! !

!UPackage methodsFor: 'initialize-release' stamp: 'ls 7/29/2004 15:39'!
depends: aCollection
	depends _ Set withAll: aCollection! !

!UPackage methodsFor: 'accessing' stamp: 'ls 7/28/2004 09:53'!
description
	^description! !

!UPackage methodsFor: 'initialize-release' stamp: 'ls 7/27/2004 21:17'!
description: aString
	description _ aString! !

!UPackage methodsFor: 'comparing' stamp: 'ls 7/28/2004 09:58'!
hash
	^self name hash bitXor: self version hash! !

!UPackage methodsFor: 'accessing' stamp: 'ls 2/13/2005 18:05'!
homepage
	"a homepage describing the package, or nil if there isn't one"
	^homepage! !

!UPackage methodsFor: 'initialize-release' stamp: 'ls 2/13/2005 12:20'!
homepage: aURL
	homepage _ aURL! !

!UPackage methodsFor: 'initialize-release' stamp: 'ls 2/13/2005 18:05'!
initialize
	name _ '(unnamed package)'.
	depends _ Set new.
	conflicts _ Set new.
	provides _ Set new.
	description _ ''.
	url _ 'file:///dev/null' asUrl.
	homepage _ nil.
	version _ UVersion readFromString: '0'.
	maintainer _ ''.
! !

!UPackage methodsFor: 'installing' stamp: 'ls 10/19/2006 10:30'!
install
	| filename doc file downloadDir |
	self url ifNil: [ ^self ].
	
	downloadDir _ FileDirectory default directoryNamed: 'universetmp'.
	downloadDir assureExistence.
	
	filename _ self url path last.
	(downloadDir isAFileNamed: filename)
	ifFalse: [
		"download the file"
		doc _ url retrieveContents.
		((doc contentType asString = 'text/plain') and: [
			doc content beginsWith: 'error']) ifTrue: [
			"HACK to see if the download failed; the real solution is to make retrieveContents report errors"
			^self error: 'download failed' ].
		file _ downloadDir newFileNamed: filename.
		file binary.
		file nextPutAll: doc content.
		file close. ].
	
	UInstaller installFileNamed: (downloadDir fullNameFor: filename).
	
		! !

!UPackage methodsFor: 'accessing' stamp: 'ls 2/13/2005 12:33'!
maintainer
	^maintainer ifNil: [ '' ]! !

!UPackage methodsFor: 'initialize-release' stamp: 'ls 2/13/2005 12:32'!
maintainer: aString
	maintainer _ aString! !

!UPackage methodsFor: 'accessing' stamp: 'ls 7/28/2004 09:53'!
name
	^name! !

!UPackage methodsFor: 'initialize-release' stamp: 'ls 7/27/2004 21:17'!
name: aString
	name _ aString! !

!UPackage methodsFor: 'printing' stamp: 'ls 7/27/2004 21:19'!
printOn: aStream
	aStream
		nextPutAll: name;
		nextPutAll: ' version ';
		print: version! !

!UPackage methodsFor: 'serializing' stamp: 'ls 2/13/2005 13:29'!
printXMLPackageList: names on: stream
	names do: [ :n |
		stream nextPutAll: ' <packagename>'; nextPutAll: n escapeEntities; nextPutAll: '</packagename>' ].! !

!UPackage methodsFor: 'accessing' stamp: 'ls 2/13/2005 12:29'!
provides
	^provides ifNil: [ Set new ]! !

!UPackage methodsFor: 'initialize-release' stamp: 'ls 2/13/2005 12:27'!
provides: aCollection
	provides _ Set withAll: aCollection! !

!UPackage methodsFor: '*universes-messages' stamp: 'ls 10/20/2006 18:37'!
stringArrayEncoding
	^Array streamContents: [ :str |
		str
			nextPut: self name;
			nextPut: self version printString;
			nextPut: self description;
			nextPut: (self url ifNil: [ '(no download url)' ] ifNotNil: [ self url toText ]);
			nextPut: (self homepage ifNil: [ '' ] ifNotNil: [ self homepage toText ]);
			nextPut: self maintainer;
			nextPut: self provides size printString;
			nextPutAll: self provides;
			nextPut: self depends size printString;
			nextPutAll: self depends;
			nextPut: self conflicts size printString;
			nextPutAll: self conflicts ]! !

!UPackage methodsFor: 'accessing' stamp: 'ls 10/19/2006 10:30'!
url
	"The location of the package to install.  If it is nil, then the package is virtual and only has meaning for its dependencies."
	^url! !

!UPackage methodsFor: 'initialize-release' stamp: 'ls 7/27/2004 21:18'!
url: aURL
	url _ aURL! !

!UPackage methodsFor: 'accessing' stamp: 'ls 7/27/2004 21:32'!
version
	^version! !

!UPackage methodsFor: 'initialize-release' stamp: 'ls 7/27/2004 21:17'!
version: aVersion
	version _ aVersion.
	! !

!UPackage methodsFor: 'serializing' stamp: 'ls 2/13/2005 13:28'!
xmlForExport
	^String streamContents: [ :str |
		str
			nextPutAll: '<package>'; cr;
			nextPutAll: '<name>'; nextPutAll: self name escapeEntities; nextPutAll: '</name>'; cr;
			nextPutAll: '<version>'; nextPutAll:  self version printString escapeEntities; nextPutAll: '</version>'; cr;
			nextPutAll: '<description>'; nextPutAll: self description escapeEntities; nextPutAll: '</description>'; cr;
			nextPutAll: '<url>'; nextPutAll: self url toText escapeEntities; nextPutAll: '</url>'; cr.
		self homepage ifNotNil: [
			str nextPutAll: '<homepage>'; nextPutAll:  self homepage toText escapeEntities; nextPutAll: '</homepage>'; cr ].
		str nextPutAll: '<maintainer>'; nextPutAll: self maintainer escapeEntities; nextPutAll: '</maintainer>'; cr.
			
		str nextPutAll: '<provides>'.
		self printXMLPackageList: self provides on: str.
		str nextPutAll: '</provides>'.
		str nextPutAll: '<depends>'.
		self printXMLPackageList: self depends on: str.
		str nextPutAll: '</depends>'.
		str nextPutAll: '<conflicts>'.
		self printXMLPackageList: self conflicts on: str.
		str nextPutAll: '</conflicts>'.

		str nextPutAll: '</package>'; cr. ]! !

Object subclass: #UPackageSerializer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Serialization'!

!UPackageSerializer commentStamp: 'ls 2/13/2005 12:49' prior: 0!
A class for loading and saving lists of packages!

Object subclass: #UPolicy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Policy'!

!UPolicy commentStamp: '<historical>' prior: 0!
A policy for manipulations on a universe.  All of the methods return 'true' on success or on allowing the requested operation, or 'false' on an error or if the operation is not allowed.  By default everything is disallowed.

Note that since policy is completely implemented on the server, there is no requirement that a particular UUniverse has a policy describable with this class or a subclass.  A particular server can always modify UUniverseServer to implement an arbitrary policy.!

UPolicy subclass: #UPStable
	instanceVariableNames: 'masterUser masterPassword'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Policy'!

!UPStable commentStamp: '<historical>' prior: 0!
A policy somewhat suitable for stable versions.  All updates must come through a single master userid and password.!

!UPStable methodsFor: 'policies' stamp: 'ls 7/29/2004 17:59'!
addUser: user withPassword: password andEmail: email
	^UPolicyResponse denied! !

!UPStable methodsFor: 'policies' stamp: 'ls 7/29/2004 17:59'!
changeUser: user withPassword: password toHavePassword: newPassword andNewEmail: newEmail
	"the changes must be made on the server, not over the standard protocol"
	^UPolicy denied! !

!UPStable methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 22:08'!
masterPassword: password
	masterPassword _ password! !

!UPStable methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 22:08'!
masterUser: userName
	masterUser _ userName! !

!UPStable methodsFor: 'policies' stamp: 'ls 7/29/2004 18:00'!
package: package mayBeAddedBy: user withPassword: password
	^(user = masterUser and: [ password = masterPassword ])
		ifTrue: [ UPolicyResponse allowed ]
		ifFalse: [ UPolicyResponse denied ]! !

!UPStable methodsFor: 'policies' stamp: 'ls 7/29/2004 18:00'!
packageNamed: packageName  withVersion: version  mayBeRemovedBy: user  withPassword: password
	(user = masterUser and: [ password = masterPassword ])
		ifTrue: [ ^UPolicyResponse allowed ]
		ifFalse: [ ^UPolicyResponse denied ]! !

UPolicy subclass: #UPWild
	instanceVariableNames: 'accounts'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Policy'!

!UPWild commentStamp: '<historical>' prior: 0!
This is the wild-n-wooly policy.  Anyone may create a new account, and the first person to try to add or remove a package with a given name comes to exclusively own that package name.  Only the owner of a package name may make changes to packages with that name.!

!UPWild class methodsFor: 'reasonable names' stamp: 'ls 7/29/2004 16:51'!
isReasonablePackageName: aString
	^aString allSatisfy: [ :c | c isAlphaNumeric or: [ ' -.' includes: c ]]! !

!UPWild class methodsFor: 'reasonable names' stamp: 'ls 2/15/2005 23:45'!
isReasonableUsername: aString
	^aString isEmpty not and: [ aString allSatisfy: [ :c | c isAlphaNumeric ] ]! !

!UPWild methodsFor: 'policies' stamp: 'ls 7/29/2004 16:49'!
addUser: username withPassword: password  andEmail: email
	| newAccount |
	(accounts anySatisfy: [ :acc | acc username = username]) ifTrue: [
		"already an account here"
		^UPolicyResponse denied: 'account already exists' ].
	
	(self class isReasonableUsername: username) ifFalse: [
		^UPolicyResponse denied: 'invalid account name' ].
	
	newAccount _ UAccount new.
	newAccount username: username.
	newAccount password: password.
	newAccount email: email.
	
	accounts add: newAccount.
	^UPolicyResponse allowed! !

!UPWild methodsFor: 'policies' stamp: 'ls 2/13/2005 16:38'!
changeUser: username withPassword: password toHavePassword: newPassword andNewEmail: newEmail
	| account |
	account _ self findAccount: username withPassword: password.
	account ifNil: [ ^UPolicyResponse denied: 'username not present or password does not match' ].
	
	newPassword isEmpty ifFalse: [account password: newPassword ].
	newEmail isEmpty ifFalse: [account email: newEmail ].
	^UPolicyResponse allowed! !

!UPWild methodsFor: 'policies' stamp: 'ls 7/28/2004 18:14'!
findAccount: username withPassword: password
	| account |
	account _ accounts detect: [ :acc | acc username = username] ifNone: [
		"no such account"
		^nil ].
	
	account password = password ifFalse:[
		"wrong password"
		^nil ].
	
	^account! !

!UPWild methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 21:35'!
initialize
	accounts _ OrderedCollection new! !

!UPWild methodsFor: 'policies' stamp: 'ls 7/28/2004 21:34'!
package: aPackage  mayBeAddedBy: username  withPassword: password
	^self tryToGivePackageName: aPackage name toUsername: username withPassword: password! !

!UPWild methodsFor: 'policies' stamp: 'ls 7/28/2004 18:15'!
packageNamed: packageName withVersion: version mayBeRemovedBy: username withPassword: password
	^self tryToGivePackageName: packageName toUsername: username withPassword: password! !

!UPWild methodsFor: 'policies' stamp: 'ls 7/29/2004 16:51'!
tryToGivePackageName: packageName toUsername: username  withPassword: password
	| account |
	(self class isReasonablePackageName: packageName) ifFalse: [
		^UPolicyResponse denied: 'invalid package name' ].
	
	account _ self findAccount: username withPassword: password.
	account ifNil: [ ^UPolicyResponse denied: 'incorrect password or no such user' ].
	
	(account ownsPackageName: packageName) ifTrue: [
		^UPolicyResponse allowed ].
	
	(accounts anySatisfy: [ :acc | acc ownsPackageName: packageName ]) ifTrue: [
		^UPolicyResponse denied: 'package is owned by another' ].
	
	account addPackageName: packageName.
	^UPolicyResponse allowed! !

UPolicy subclass: #UPermissivePolicy
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Policy'!

!UPermissivePolicy commentStamp: '<historical>' prior: 0!
A policy that allows anything.
!

!UPermissivePolicy methodsFor: 'policies' stamp: 'ls 7/29/2004 16:48'!
addUser: user  withPassword: password  andEmail: email
	^UPolicyResponse allowed! !

!UPermissivePolicy methodsFor: 'policies' stamp: 'ls 7/29/2004 16:48'!
changeUser: user withPassword: password toHavePassword: newPassword andNewEmail: newEmail
	^UPolicyResponse allowed! !

!UPermissivePolicy methodsFor: 'policies' stamp: 'ls 7/29/2004 16:48'!
package: aPackage  mayBeAddedBy: user  withPassword: password
	^UPolicyResponse allowed! !

!UPermissivePolicy methodsFor: 'policies' stamp: 'ls 7/29/2004 16:48'!
packageNamed: packageName  withVersion: version  mayBeRemovedBy: user  withPassword: password
	^UPolicyResponse allowed! !

!UPolicy methodsFor: 'policies' stamp: 'ls 7/29/2004 16:47'!
addUser: user  withPassword: password  andEmail: email
	^UPolicyResponse denied! !

!UPolicy methodsFor: 'policies' stamp: 'ls 7/29/2004 16:47'!
changeUser: user withPassword: password toHavePassword: newPassword andNewEmail: newEmail
	^UPolicyResponse denied! !

!UPolicy methodsFor: 'policies' stamp: 'ls 7/29/2004 16:47'!
package: aPackage  mayBeAddedBy: user  withPassword: password
	^UPolicyResponse denied! !

!UPolicy methodsFor: 'policies' stamp: 'ls 7/29/2004 16:47'!
packageNamed: packageName  withVersion: version  mayBeRemovedBy: user  withPassword: password
	^UPolicyResponse denied! !

Object subclass: #UPolicyResponse
	instanceVariableNames: 'allowed reason'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Policy'!

!UPolicyResponse commentStamp: '<historical>' prior: 0!
A response to a policy query.!

!UPolicyResponse class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 16:47'!
allowed
	^self allowed: nil! !

!UPolicyResponse class methodsFor: 'instance creation' stamp: 'ls 7/30/2004 10:34'!
allowed: reason
	^self allowed: true  reason: reason! !

!UPolicyResponse class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 16:46'!
allowed: aBoolean  reason: aReason
	^self basicNew
		allowed: aBoolean;
		reason: (aReason ifNil: ['no reason given']);
		yourself! !

!UPolicyResponse class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 16:46'!
denied
	^self denied: nil! !

!UPolicyResponse class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 17:58'!
denied: reason
	^self allowed: false  reason: reason! !

!UPolicyResponse class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 16:47'!
new
	self shouldNotImplement ! !

!UPolicyResponse methodsFor: 'accessing' stamp: 'ls 7/29/2004 17:56'!
allowed
	^allowed! !

!UPolicyResponse methodsFor: 'accessing' stamp: 'ls 7/29/2004 17:56'!
allowed: anObject
	allowed _ anObject! !

!UPolicyResponse methodsFor: 'accessing' stamp: 'ls 7/29/2004 17:58'!
reason
	^reason! !

!UPolicyResponse methodsFor: 'accessing' stamp: 'ls 7/29/2004 17:56'!
reason: anObject
	reason _ anObject! !

Object subclass: #UUniverseClient
	instanceVariableNames: 'universe inMessages outMessages socket stringSocket lastConnectionStart'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Client'!

!UUniverseClient commentStamp: 'ls 7/30/2004 14:58' prior: 0!
A client for talking to a universe server.

The universe must be a UStandardUniverse.  The client will track update the universe automatically as messages come in.
!

!UUniverseClient class methodsFor: 'instance creation' stamp: 'ls 7/30/2004 15:06'!
forUniverse: aStandardUniverse
	^self basicNew
		initialize: aStandardUniverse;
		yourself! !

!UUniverseClient class methodsFor: 'class initialization' stamp: 'ls 2/13/2005 15:45'!
initialize
	Preferences removePreference: #universesUsesHTTP 
! !

!UUniverseClient class methodsFor: 'instance creation' stamp: 'ls 7/30/2004 15:06'!
new
	^self forUniverse: UUniverse systemUniverse! !

!UUniverseClient methodsFor: 'public' stamp: 'ls 7/30/2004 15:10'!
disconnect
	"explicitly close the connection"
	socket ifNotNil: [ socket destroy.  socket _ nil ].
	stringSocket ifNotNil: [ stringSocket destroy.  stringSocket _ nil ].! !

!UUniverseClient methodsFor: 'initialization' stamp: 'ls 8/5/2004 17:16'!
initialize: aUniverse
	universe _ aUniverse.
	
	inMessages _ OrderedCollection new.
	outMessages _ OrderedCollection new.
	
	lastConnectionStart _ DateAndTime epoch.! !

!UUniverseClient methodsFor: 'networking' stamp: 'ls 8/4/2004 15:46'!
newInMessage: aMessage
	aMessage applyToClient: self.
	inMessages add: aMessage.
	! !

!UUniverseClient methodsFor: 'package list' stamp: 'ls 7/30/2004 14:59'!
newPackageList: newPackages
	universe packages: newPackages.
	! !

!UUniverseClient methodsFor: 'package list' stamp: 'ls 7/30/2004 15:00'!
packageAdded: newPackage
	universe addPackage: newPackage! !

!UUniverseClient methodsFor: 'networking' stamp: 'ls 2/15/2005 21:44'!
processIO
	| rawMsg |
	(stringSocket notNil and: [ stringSocket isConnected not ]) ifTrue: [
		"connection has died"
		stringSocket destroy.
		stringSocket _ nil ].

	
	(outMessages isEmpty not and: [ socket isNil and: [ stringSocket isNil ] ]) ifTrue: [
		"there are outgoing messages queued but there is no stringSocket"
		(DateAndTime now - lastConnectionStart) > (Duration minutes: 1) ifTrue: [
			self startConnecting ] ].
	
	socket ifNotNil: [
		"a connection is in progress"
		
		socket isConnected ifTrue: [
			"connection completed"
			stringSocket _ StringSocket on: socket.
			universe shortName ifNotNil: [
				outMessages addFirst: (UMProtocolVersion version: 1).
				outMessages addFirst: (UMSelectServer shortName: universe shortName) ].
			socket _ nil. ]
		ifFalse: [
			socket isWaitingForConnection ifFalse: [
				"the connection failed"
				inMessages add: (UMConnectionFailed description: 'connection failed').
				^self disconnect ] ] ].

	
	stringSocket ifNil: [ ^self ].
		
	[ outMessages isEmpty ] whileFalse: [
		stringSocket nextPut: outMessages removeFirst asStringArray ].
	
	stringSocket processIO.
	
	[	rawMsg _ stringSocket nextOrNil.
		rawMsg isNil not
	] whileTrue: [ 
		self newInMessage: (UMessage fromStringArray: rawMsg) ]! !

!UUniverseClient methodsFor: 'public' stamp: 'ls 7/30/2004 15:33'!
receivedMessagesDo: aBlock
	"check for new messages, and then evaluate aBlock for each message that is currently available"
	self processIO.
	[ inMessages isEmpty ] whileFalse: [
		aBlock value: inMessages removeFirst ]! !

!UUniverseClient methodsFor: 'package list' stamp: 'ls 7/30/2004 15:02'!
removedPackageNamed: packageName  withVersion: version
	universe removePackageNamed: packageName  withVersion: version! !

!UUniverseClient methodsFor: 'public' stamp: 'ls 2/13/2005 15:18'!
sendMessage: aMessage
	"send the specified message to the server"
	outMessages add: aMessage! !

!UUniverseClient methodsFor: 'networking' stamp: 'ls 7/30/2004 15:31'!
startConnecting
	"start a new connection to the server"
	self disconnect.
	
	lastConnectionStart _ DateAndTime now.
	
	socket _ Socket newTCP.
	socket connectTo: (NetNameResolver addressForName: universe serverName) port: universe serverPort.
! !

!UUniverseClient methodsFor: 'public' stamp: 'ls 7/30/2004 15:30'!
waitForMessage
	"block until at least one message is available"
	self notYetImplemented.   "proper implementation requires changes to ObjectSocket"
	
	[ inMessages isEmpty ] whileTrue: [
		(socket isNil and: [  stringSocket isNil and: [ outMessages isEmpty ] ]) ifTrue: [
			self error: 'no more messages will every be available' ].
		
		socket ifNotNil: [ socket waitForConnectionFor: 60 ].
		stringSocket ifNotNil: [ stringSocket wait ].
		self processIO ].
! !

Object subclass: #UUniverseEditor
	instanceVariableNames: 'universe client username password email usernameField passwordField fields packageEditors accountEditor selectedPackageIndex'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Editor'!

!UUniverseEditor commentStamp: '<historical>' prior: 0!
A tool for editing a remote universe.
!

!UUniverseEditor class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 10:23'!
forUniverse: aStandardUniverse
	^self basicNew
		initialize: aStandardUniverse;
		yourself! !

!UUniverseEditor class methodsFor: 'class initialization' stamp: 'ls 2/13/2005 16:00'!
initialize
	TheWorldMenu registerOpenCommand: {'Universe Editor'. {self. #open}}.
	Preferences setWindowColorFor: self name to: (Color r: 0.194 g: 0.645 b: 1.0).! !

!UUniverseEditor class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 18:13'!
new
	| choice choices |
	choices := UUniverse systemUniverse standardUniverses asArray.
	choices isEmpty ifTrue: [ ^self error: 'no standard universes installed' ].
	choices size = 1 ifTrue: [
		choice _ choices anyOne ]
	ifFalse: [
		| menu |
		menu _
			SelectionMenu
				labels: (choices collect: [ :u | u description ])
				selections: choices.
		choice _ menu startUpWithCaption: 'edit which universe?'.
		choice ifNil: [ ^self ] ].
	
	^self forUniverse: choice! !

!UUniverseEditor class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 18:13'!
open
	^self new open! !

!UUniverseEditor class methodsFor: 'class initialization' stamp: 'ls 7/29/2004 18:14'!
unload
	TheWorldMenu unregisterOpenCommand: 'Universe Editor'! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 2/13/2005 17:34'!
acceptFields
	fields do: [ :f | f accept ]! !

!UUniverseEditor methodsFor: 'account' stamp: 'ls 7/28/2004 18:00'!
accountUpdatedWithUsername: newUsername  password:  newPassword  email: newEmail
	self acceptFields.
	username _ newUsername.
	password _ newPassword.
	email _ newEmail.
	
	self changed: #username.
	self changed: #password.
	self changed: #email.
	
	self closeAccountEditor! !

!UUniverseEditor methodsFor: 'package list' stamp: 'ls 2/13/2005 16:25'!
anyPackageSelected
	^selectedPackageIndex > 0! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 7/28/2004 17:58'!
closeAccountEditor
	accountEditor ifNil: [ ^self ].
	accountEditor window delete.
	accountEditor _ nil.! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 7/28/2004 17:12'!
closeEditorForPackage: package
	| matchingEditors |
	matchingEditors _ packageEditors select: [ :p | p package = package ].
	matchingEditors do: [ :editor |
		editor window delete.
		packageEditors remove: editor ].! !

!UUniverseEditor methodsFor: 'account' stamp: 'ls 2/13/2005 16:31'!
createAccount
	self acceptFields.

	email _ FillInTheBlankMorph request: 'your email address?'.
	email = '' ifTrue: [ ^self ].

	self sendMessage: (UMAddAccount username: username password: password email: email).
	! !

!UUniverseEditor methodsFor: 'account' stamp: 'ls 2/13/2005 16:52'!
editAccount
	| editor |
	self acceptFields.
	self closeAccountEditor.
	
	editor _ UAccountEditor
		username: username
		password: password
		email:  ''
		whenDone: [ :oldPassword :newPassword :newEmail |
			password _ oldPassword.
			self sendMessage: (UMEditAccount username: username password: password newPassword: newPassword newEmail: newEmail) ].
		
	editor openInMorphic.
	
	accountEditor _ editor.! !

!UUniverseEditor methodsFor: 'initialization' stamp: 'ls 2/13/2005 17:16'!
initialize: universe0
	universe _ universe0.
	universe addDependent: self.

	client _ UUniverseClient forUniverse: universe.
	username _ Utilities authorInitialsPerSe.
	password _ ''.
	
	packageEditors _ Set new.

	selectedPackageIndex _ 0.
! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 2/13/2005 16:02'!
makeButtonWithAction: selector andGetState: getStateSelector andLabel: aString
	^(PluggableButtonMorph on: self getState: getStateSelector action: selector)
		label: aString;
		useRoundedCorners;
		vResizing: #spaceFill;
		hResizing: #spaceFill;
		onColor: self defaultBackgroundColor offColor: self defaultBackgroundColor muchLighter;
		yourself! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 2/13/2005 16:02'!
makeButtonWithAction: selector  andLabel: aString
	^self makeButtonWithAction: selector andGetState: #returnTrue andLabel: aString! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 2/15/2005 22:02'!
morphicView
	| win universeDescription buttonList usernameRow passwordRow button  usernamePasswordArea packageList |
	win _ SystemWindow labelled: 'Universe Editor'.
	win model: self.
	
	universeDescription := PluggableTextMorph on: self text: #universeDescription accept: nil.
	universeDescription hideScrollBarsIndefinitely.
	win addMorph: universeDescription frame: (0@0 extent: 1@0.1).
	
	buttonList _ AlignmentMorph newColumn.
	buttonList cellInset: 0@3.
	win addMorph: buttonList frame: (0@0.5 extent: 0.5@0.5).
	
	
	usernamePasswordArea _ AlignmentMorph newColumn.
	win addMorph: usernamePasswordArea frame: (0@0.1 extent: 0.5@0.4).

	usernameRow _ UInterfaceUtilities makeFieldRowNamed: 'username' getSelector: #username setSelector: #username: for: self.
	usernamePasswordArea addMorphBack: usernameRow.
	
	passwordRow _ UInterfaceUtilities makeFieldRowNamed: 'password:' getSelector: #password setSelector: #password: isPassword: true for: self.
	usernamePasswordArea addMorphBack: passwordRow.
	
	button _ self makeButtonWithAction: #createAccount andLabel: 'createAccount'.
	buttonList addMorphBack: button.
	button _ self makeButtonWithAction: #editAccount andLabel: 'edit account'.
	buttonList addMorphBack: button.
	button _ self makeButtonWithAction: #newPackage andLabel: 'new package'.
	buttonList addMorphBack: button.
	button _ self makeButtonWithAction: #newPackageVersion andGetState: #anyPackageSelected andLabel: 'new package version'.
	buttonList addMorphBack: button.
	button _ self makeButtonWithAction: #removeVersion andGetState: #anyPackageSelected andLabel: 'remove package version'.
	buttonList addMorphBack: button.
	button _ self makeButtonWithAction: #requestPackageList andLabel: 'update package list'.
	buttonList addMorphBack: button.

	packageList _ PluggableListMorph on: self list: #packageDescriptions  selected: #selectedPackageIndex changeSelected: #selectedPackageIndex: menu: nil.
	win addMorph: packageList frame: ((0.5@0.1) extent: (0.5@0.9)).

	
	^win! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 7/28/2004 22:00'!
newPackage
	| editor |
	self acceptFields.

	editor _ UPackageEditor package: UPackage new whenComplete: [ :p |
		self acceptFields.
		self sendMessage: (UMAddPackage username: username password: password package: p) ].
	editor openInMorphic.
	packageEditors add: editor.
! !

!UUniverseEditor methodsFor: 'package editing' stamp: 'ls 2/15/2005 22:06'!
newPackageVersion
	| package editor newPackage |
	self anyPackageSelected ifFalse: [ ^self ].
	self acceptFields.
	package _ self selectedPackage.
	
	newPackage _ package deepCopy.
	newPackage version: (UVersion readFromString: (newPackage version asString, 'new')).

	editor _ UPackageEditor package: newPackage whenComplete: [ :p |
		self acceptFields.
		self sendMessage: (UMAddPackage username: username password: password package: p) ].

	editor openInMorphic.
	packageEditors add: editor.
! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 2/13/2005 17:34'!
noteField: field 
	"note that the receiver has the specified text field"
	fields ifNil: [fields := OrderedCollection new].
	fields add: field! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 7/29/2004 16:27'!
open
	self morphicView openInWorld.
	"self requestPackageList."! !

!UUniverseEditor methodsFor: 'package list' stamp: 'ls 2/13/2005 16:26'!
packageDescriptions
	^self sortedPackages collect: [ :p |		
		p printString. ]! !

!UUniverseEditor methodsFor: 'package list' stamp: 'ls 2/13/2005 16:27'!
packagesChanged
	self selectedPackageIndex: 0.
	
	self changed: #packageDescriptions.
	! !

!UUniverseEditor methodsFor: 'attributes' stamp: 'ls 7/28/2004 15:54'!
password
	^password! !

!UUniverseEditor methodsFor: 'attributes' stamp: 'ls 7/28/2004 16:18'!
password: aString
	password _ aString asString.
	^true! !

!UUniverseEditor methodsFor: 'networking' stamp: 'ls 2/13/2005 17:16'!
processNetworking
	client receivedMessagesDo: [ :message |
		message applyToEditor: self ].
! !

!UUniverseEditor methodsFor: 'package editing' stamp: 'ls 2/13/2005 17:20'!
removeVersion
	| package |
	self anyPackageSelected ifFalse: [ ^self ].
	self acceptFields.

	package _ self selectedPackage.

	(self confirm: ('Delete ', 	package printString, '?')) ifFalse: [
		^self ].

	self sendMessage: (UMRemovePackage username: username password: password packageName: package name packageVersion: package version).
! !

!UUniverseEditor methodsFor: 'package list' stamp: 'ls 7/29/2004 16:23'!
requestPackageList
	self sendMessage: (UMRequestPackages new).
	! !

!UUniverseEditor methodsFor: 'user interface' stamp: 'ls 2/13/2005 16:02'!
returnTrue
	^true! !

!UUniverseEditor methodsFor: 'package list' stamp: 'ls 2/13/2005 16:27'!
selectedPackage
	^self sortedPackages at: self selectedPackageIndex! !

!UUniverseEditor methodsFor: 'package list' stamp: 'ls 2/13/2005 16:27'!
selectedPackageIndex
	^selectedPackageIndex! !

!UUniverseEditor methodsFor: 'package list' stamp: 'ls 2/13/2005 16:27'!
selectedPackageIndex: anInteger
	selectedPackageIndex _ anInteger.
	self changed: #selectedPackageIndex.
! !

!UUniverseEditor methodsFor: 'networking' stamp: 'ls 7/30/2004 15:40'!
sendMessage: aMessage
	client sendMessage: aMessage.
	! !

!UUniverseEditor methodsFor: 'package list' stamp: 'ls 2/13/2005 16:27'!
sortedPackages
	^universe packages asSortedCollection: [ :p1 :p2 |
		p1 name < p2 name or: [
			p1 name = p2 name and: [ p1 version < p2 version ] ] ].
	! !

!UUniverseEditor methodsFor: 'stepping' stamp: 'ls 7/28/2004 17:01'!
step
	self processNetworking! !

!UUniverseEditor methodsFor: 'stepping' stamp: 'ls 7/28/2004 17:01'!
stepTimeIn: window
	^10! !

!UUniverseEditor methodsFor: 'attributes' stamp: 'ls 7/29/2004 16:21'!
universeDescription 
	^universe description! !

!UUniverseEditor methodsFor: 'package list' stamp: 'ls 2/13/2005 16:27'!
update: aSymbol
	aSymbol = #packages ifTrue: [ self packagesChanged ]! !

!UUniverseEditor methodsFor: 'attributes' stamp: 'ls 7/28/2004 15:53'!
username
	^username! !

!UUniverseEditor methodsFor: 'attributes' stamp: 'ls 7/28/2004 16:13'!
username: aString
	username _ aString asString.
	^true! !

!UUniverseEditor methodsFor: 'stepping' stamp: 'ls 7/28/2004 17:01'!
wantsSteps
	^true! !

Object subclass: #UUniverseMultiServer
	instanceVariableNames: 'servers port connectionQueue connections connectionVersions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Server'!

!UUniverseMultiServer commentStamp: 'ls 2/13/2005 14:51' prior: 0!
A multi-server server.  This listens on one port, and dispatches to whichever universe was requested.

An active server needs someone to call #step periodically on it, in order for it to process networking, save checkpoints, etc.!

!UUniverseMultiServer class methodsFor: 'defaults' stamp: 'ls 2/13/2005 14:32'!
defaultPort
	^3702! !

!UUniverseMultiServer methodsFor: 'networking' stamp: 'ls 2/15/2005 22:00'!
acceptConnection: stringSocket
	stringSocket nextPut: (UMProtocolVersion version: 1) asStringArray.
	connections add: stringSocket! !

!UUniverseMultiServer methodsFor: 'networking' stamp: 'ls 2/13/2005 14:29'!
acceptConnectionOn: socket
	self acceptConnection: (StringSocket on: socket).
	! !

!UUniverseMultiServer methodsFor: 'initialize-release' stamp: 'ls 2/13/2005 14:33'!
addServer: server
	servers add: server! !

!UUniverseMultiServer methodsFor: 'initialize-release' stamp: 'ls 2/13/2005 14:49'!
addServers: newServers
	newServers do: [ :s | self addServer: s ]! !

!UUniverseMultiServer methodsFor: 'networking' stamp: 'ls 2/13/2005 14:29'!
checkForNewConnections
	connectionQueue ifNil: [ ^self ].
	[ connections size < 100 ] whileTrue: [
		| newSocket |
		newSocket _ connectionQueue getConnectionOrNil.
		newSocket ifNil: [ ^self ].
		connections add: (StringSocket on: newSocket) ].
	! !

!UUniverseMultiServer methodsFor: 'networking' stamp: 'ls 2/13/2005 14:30'!
destroyConnection: aConnection
	aConnection destroy.
	connections remove: aConnection ifAbsent: [].
	! !

!UUniverseMultiServer methodsFor: 'initialize-release' stamp: 'ls 2/13/2005 14:33'!
initialize
	servers _ Set new.
	port _ UUniverseMultiServer defaultPort.
	connections _ Set new.
! !

!UUniverseMultiServer methodsFor: 'networking' stamp: 'ls 2/13/2005 14:32'!
processConnection: aConnection
	| message |
	aConnection isConnected ifFalse: [ ^self destroyConnection: aConnection ].
	
	"process all incoming messages.  Note that some messages move the connection to one of the subsidiary servers, so be careful not to process messages after that happens"
	aConnection processIO.
	[ 	(connections includes: aConnection) and: [
			message _ aConnection nextOrNil.
	 	 	message notNil ]
	] whileTrue: [
	  	self processRawMessage: message fromConnection: aConnection ].

	(connections includes: aConnection) ifFalse: [ ^self ].

	aConnection isConnected
		ifTrue: [ aConnection processIO.  "start sending out the response" ]
		ifFalse: [ self destroyConnection: aConnection ]
! !

!UUniverseMultiServer methodsFor: 'networking' stamp: 'ls 2/13/2005 14:30'!
processConnections
	connections copy do: [ :c |
		self processConnection: c ]! !

!UUniverseMultiServer methodsFor: 'networking' stamp: 'ls 2/13/2005 14:51'!
processNetworking
	self checkForNewConnections.
	self processConnections.
! !

!UUniverseMultiServer methodsFor: 'messages' stamp: 'ls 2/13/2005 14:34'!
processRawMessage: aStringArray  fromConnection: connection
	| message |
	message _ UMessage fromStringArray: aStringArray.
	message applyToMultiServer: self forConnection: connection.
! !

!UUniverseMultiServer methodsFor: 'networking' stamp: 'ls 2/13/2005 16:08'!
startListening
	self stopListening.
	connectionQueue _ ConnectionQueue portNumber: port queueLength: 5.
	! !

!UUniverseMultiServer methodsFor: 'stepping' stamp: 'ls 2/13/2005 14:50'!
step
	self processNetworking.
	servers do: [ :server | server step ].
! !

!UUniverseMultiServer methodsFor: 'networking' stamp: 'ls 2/13/2005 16:08'!
stopListening	
	connectionQueue ifNotNil: [
		connectionQueue destroy.
		connectionQueue _ nil ].
	! !

!UUniverseMultiServer methodsFor: 'messages' stamp: 'ls 2/13/2005 16:18'!
switchConnection: aConnection  toServerNamed: serverName
	| server |
	server _ servers detect: [ :s | s universe shortName = serverName ] ifNone: [
		aConnection nextPut: (UMError description: 'no such server here') asStringArray.
		^self ].

	server acceptConnection: aConnection.
	connections remove: aConnection.
! !

Object subclass: #UUniverseServer
	instanceVariableNames: 'universe policy saveDirectory packageListFilename lastSaveTime connectionQueue connections'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Server'!

!UUniverseServer commentStamp: 'ls 2/13/2005 13:45' prior: 0!
A server holding the authoratative information about a universe.  Clients may make requests to view and update the universe.

The server does not manage its own thread; it requires that processNetworking is called periodically.
!

!UUniverseServer class methodsFor: 'instance creation' stamp: 'ls 7/29/2004 09:29'!
forSaveDirectory: aDirectory
	| universe |
	universe _ self forUniverse: UUniverse new.
	universe saveDirectory: aDirectory.
	universe loadFromCheckpoint.
	^universe! !

!UUniverseServer class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 10:31'!
forUniverse: universe
	^self basicNew initializeForUniverse: universe.
	! !

!UUniverseServer class methodsFor: 'instance creation' stamp: 'ls 7/28/2004 10:31'!
new
	^self shouldNotImplement ! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 2/15/2005 22:00'!
acceptConnection: stringSocket
	stringSocket nextPut: (UMProtocolVersion version: 1) asStringArray.
	connections add: stringSocket! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 7/28/2004 11:02'!
acceptConnectionOn: socket
	self acceptConnection: (StringSocket on: socket).
	! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 7/28/2004 13:15'!
checkForNewConnections
	connectionQueue ifNil: [ ^self ].
	[ connections size < 10 ] whileTrue: [
		| newSocket |
		newSocket _ connectionQueue getConnectionOrNil.
		newSocket ifNil: [ ^self ].
		connections add: (StringSocket on: newSocket) ].
	! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 8/3/2004 18:10'!
comancheServiceName
	^'universe server on ', universe serverPort printString! !

!UUniverseServer methodsFor: 'editing' stamp: 'ls 7/29/2004 16:53'!
connection: connection requestedAccountChangeForUsername: username  password: password  newPassword: newPassword newEmail: newEmail
	| response |
	response _ policy changeUser: username withPassword: password toHavePassword: newPassword andNewEmail: newEmail.
	response allowed ifFalse: [
		^self
			sendError: 'changing account for ', username, ' failed (', response reason, ')'
			onConnection: connection].
		
	self sendMessage: (UMEditedAccount username: username newPassword: newPassword newEmail: newEmail) onConnection: connection! !

!UUniverseServer methodsFor: 'editing' stamp: 'ls 7/29/2004 16:53'!
connection: connection requestedAccountWithUsername: username  password: password  email: email 
	| response |
	response _ policy addUser: username withPassword: password andEmail: email.
	response allowed ifFalse: [
		self
			sendError: 'adding account for ', username, ' failed (', response reason, ')'
			onConnection: connection].! !

!UUniverseServer methodsFor: 'editing' stamp: 'ls 7/29/2004 16:54'!
connection: connection requestedForUsername: username  andPassword: password  toAddPackage: package
	| response |
	response _ policy package: package mayBeAddedBy: username withPassword: password.
	
	response allowed
		ifFalse: [
			^self 
				sendError: 'adding package ', package name, ' failed (', response reason, ')'
				onConnection: connection].
		
	universe addPackage: package.


	self sendMessage: (UMPackageAdded package: package) onConnection: connection.! !

!UUniverseServer methodsFor: 'editing' stamp: 'ls 7/29/2004 16:54'!
connection: connection requestedForUsername: username  andPassword: password  toRemovePackageNamed: packageName withVersion: version
	| packagesToRemove response |
	response _ policy packageNamed: packageName withVersion: version mayBeRemovedBy: username withPassword: password.
	
	response allowed ifFalse: [
		^self 
			sendError: 'removing package ', packageName, ' failed (', response reason, ')' 
			onConnection: connection].
		
	packagesToRemove := universe packages select: [ :p | p name = packageName and: [ p version = version ] ].
	packagesToRemove do: [ :p |
		universe removePackage: p ].
	
	self sendMessage: (UMPackageRemoved packageName: packageName version: version) onConnection: connection.! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 7/28/2004 10:47'!
destroyConnection: aConnection
	aConnection destroy.
	connections remove: aConnection ifAbsent: [].! !

!UUniverseServer methodsFor: 'initialize-release' stamp: 'ls 2/13/2005 15:20'!
initializeForUniverse: aUniverse
	universe _ aUniverse.
	policy _ UPolicy new.
	connectionQueue _ nil.
	connections _ Set new.
! !

!UUniverseServer methodsFor: 'persistence' stamp: 'ls 7/29/2004 09:25'!
loadFromCheckpoint
	"reload from a checkpoint"
	| file savedObject |
	(saveDirectory isAFileNamed: 'checkpoint')
		ifTrue: [ file _ saveDirectory readOnlyFileNamed: 'checkpoint' ]
		ifFalse: [ file _ saveDirectory readOnlyFileNamed: 'checkpoint.die' ].

	savedObject := file fileInObjectAndCode.
	file close.
	
	universe := savedObject first.
	policy := savedObject second.	! !

!UUniverseServer methodsFor: 'stepping' stamp: 'ls 8/2/2004 17:15'!
openStepperMorph
	(UServerStepperMorph new server: self; yourself) openInWorld! !

!UUniverseServer methodsFor: 'initialize-release' stamp: 'ls 2/13/2005 13:44'!
packageListFilename: filename
	packageListFilename _ filename! !

!UUniverseServer methodsFor: 'initialize-release' stamp: 'ls 7/28/2004 14:32'!
policy: aPolicy
	policy _ aPolicy! !

!UUniverseServer methodsFor: 'persistence' stamp: 'ls 2/13/2005 15:23'!
possiblySaveCheckpointAndPackageList
	saveDirectory ifNil: [^self].
	(lastSaveTime isNil 
		or: [DateAndTime now - lastSaveTime > (Duration minutes: 30)]) 
			ifTrue: 
				[self saveCheckpoint.
				self savePackageList.
				lastSaveTime := DateAndTime now]! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 7/28/2004 21:28'!
processConnection: aConnection
	| message |
	aConnection isConnected ifFalse: [ ^self destroyConnection: aConnection ].
	
	aConnection processIO.
	[ 	message _ aConnection nextOrNil.
	  	message notNil
	] whileTrue: [
	  	self processRawMessage: message fromConnection: aConnection ].

	aConnection isConnected
		ifTrue: [ aConnection processIO.  "start sending out the response" ]
		ifFalse: [ self destroyConnection: aConnection ]! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 7/28/2004 10:43'!
processConnections
	connections copy do: [ :c |
		self processConnection: c ]! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 2/13/2005 15:19'!
processNetworking
	self checkForNewConnections.
	self processConnections.
	! !

!UUniverseServer methodsFor: 'messages' stamp: 'ls 7/28/2004 13:12'!
processRawMessage: aStringArray  fromConnection: connection
	| message |
	message _ UMessage fromStringArray: aStringArray.
	message applyToServer: self forConnection: connection.
! !

!UUniverseServer methodsFor: 'persistence' stamp: 'ls 2/13/2005 13:43'!
saveCheckpoint
	"save a checkpoint"
	| tmpFile |
	saveDirectory deleteFileNamed: 'checkpoint.tmp'.
	
	tmpFile := saveDirectory newFileNamed: 'checkpoint.tmp'.
	(SmartRefStream on: tmpFile) nextPut: {universe.policy}; close.
	
	saveDirectory deleteFileNamed: 'checkpoint.die'.
	saveDirectory rename: 'checkpoint.tmp' toBe: 'checkpoint'.	
	saveDirectory deleteFileNamed: 'checkpoint.die'.
	! !

!UUniverseServer methodsFor: 'initialize-release' stamp: 'ls 7/29/2004 09:16'!
saveDirectory: aDirectory
	saveDirectory _ aDirectory! !

!UUniverseServer methodsFor: 'persistence' stamp: 'ls 2/13/2005 13:44'!
savePackageList
	packageListFilename ifNotNil: [
		UPackage savePackageList: universe packages onFileNamed: packageListFilename ]! !

!UUniverseServer methodsFor: 'messages' stamp: 'ls 7/28/2004 14:49'!
sendError: description onConnection: stringSocket
	self sendMessage: (UMError description: description) onConnection: stringSocket! !

!UUniverseServer methodsFor: 'messages' stamp: 'ls 7/28/2004 11:48'!
sendMessage: aMessage  onConnection: connection
	connection nextPut: aMessage asStringArray  ! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 7/28/2004 13:21'!
startListening
	self stopListening.
	connectionQueue _ ConnectionQueue portNumber: universe serverPort queueLength: 5.
	! !

!UUniverseServer methodsFor: 'stepping' stamp: 'ls 2/13/2005 15:23'!
step
	"do any necessary periodic work, including polling the network connections"

	self processNetworking.
	self possiblySaveCheckpointAndPackageList! !

!UUniverseServer methodsFor: 'networking' stamp: 'ls 7/28/2004 10:41'!
stopListening	
	connectionQueue ifNotNil: [
		connectionQueue destroy.
		connectionQueue _ nil ].
	! !

!UUniverseServer methodsFor: 'accessing' stamp: 'ls 7/28/2004 13:08'!
universe
	^universe! !

Object subclass: #UUtilities
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Model'!

!UUtilities commentStamp: 'ls 7/28/2004 10:35' prior: 0!
Universe miscellania that belong to no particular object.
!

Flasher subclass: #UServerStepperMorph
	instanceVariableNames: 'server timeOfLastFlash'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Server'!

!UServerStepperMorph commentStamp: '<historical>' prior: 0!
A morph that simply steps a UniverseServer continuously.
!

!UServerStepperMorph methodsFor: 'closing' stamp: 'ls 2/13/2005 15:20'!
delete
	super delete.
	server stopListening.
! !

!UServerStepperMorph methodsFor: 'initialization' stamp: 'ls 7/28/2004 13:41'!
initialize
	super initialize.
	timeOfLastFlash _ DateAndTime now.! !

!UServerStepperMorph methodsFor: 'initialization' stamp: 'ls 7/28/2004 13:19'!
server: aServer
	server _ aServer! !

!UServerStepperMorph methodsFor: 'stepping' stamp: 'ls 7/28/2004 13:42'!
step
	server ifNotNil: [ server step ].
	
	(DateAndTime now - timeOfLastFlash ) > (Duration milliSeconds: 3000) ifTrue: [
		super step.
		timeOfLastFlash _ DateAndTime now. ].! !

!UServerStepperMorph methodsFor: 'stepping' stamp: 'ls 7/28/2004 13:19'!
stepTime
	^10! !

!UServerStepperMorph methodsFor: 'stepping' stamp: 'ls 7/28/2004 13:19'!
wantsSteps
	^true! !

TestCase subclass: #UBrowserTestCase
	instanceVariableNames: 'universe'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Tests'!

!UBrowserTestCase methodsFor: 'Running' stamp: 'ls 1/16/2005 14:11'!
setUp
	| package |
	universe _ UStandardUniverse new.
	
	package _ UPackage new.
	package name: 'A'.
	package addDependency: 'B'.
	universe addPackage: package.
	
	package _ UPackage new.
	package name: 'B'.
	package addDependency: 'C'.
	universe addPackage: package.
	
	package _ UPackage new.
	package name: 'C'.
	package addDependency: 'D'.
	package addDependency: 'E'.
	universe addPackage: package.
	
	package _ UPackage new.
	package name: 'D'.
	universe addPackage: package.
	
	package _ UPackage new.
	package name: 'E'.
	universe addPackage: package.

	package _ UPackage new.
	package name: 'Broken'.
	package addDependency: 'NonExistent'.
	universe addPackage: package.
	
! !

!UBrowserTestCase methodsFor: 'Running' stamp: 'ls 7/29/2004 17:40'!
testBasicDependency
	| browser neededPackages |
	browser _ UUniverseBrowser new universe: universe; yourself.
	neededPackages _ browser allPackagesNeededToInstall: (universe newestPackageNamed: 'A')  orIfImpossible: [ :ign | self error: 'dependency not found' ].
	
	self should: [ neededPackages size = 5 ].
	
	browser _ UUniverseBrowser new universe: universe; yourself.
	neededPackages _ browser allPackagesNeededToInstall: (universe newestPackageNamed: 'B')  orIfImpossible: [ :ign | self error: 'dependency not found' ].
	
	self should: [ neededPackages size = 4 ].! !

!UBrowserTestCase methodsFor: 'Running' stamp: 'ls 7/29/2004 17:39'!
testBrokenDependency
	| browser neededPackages |
	browser _ UUniverseBrowser new universe: universe; yourself.
	neededPackages _ browser allPackagesNeededToInstall: (universe newestPackageNamed: 'Broken')  orIfImpossible: [ :ign | nil ].
	self should: [ neededPackages isNil ].

	! !

TestCase subclass: #UPackageTestCase
	instanceVariableNames: 'p1 p2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Tests'!

!UPackageTestCase methodsFor: 'setup' stamp: 'ls 2/13/2005 12:34'!
setUp
	p1 _ UPackage new.
	p1 name: 'Scamper'.
	p1 description: 'A web browser'.
	p1 url: 'http://www.squeak.org' asUrl.
	p1 homepage: p1 url.
	p1 version: (UVersion readFromString: '1.0').
	p1 maintainer: 'John Doe'.

	p2 _ p1 deepCopy.
! !

!UPackageTestCase methodsFor: 'comparing' stamp: 'ls 2/13/2005 12:34'!
testCompare
	self should: [ p1 = p2 ].
	self should: [ p1 hash = p2 hash ].

	p2 homepage: 'http://www.squeakland.org' asUrl.
	self shouldnt: [ p1 = p2 ].

	p2 homepage: p1 homepage.
	p1 conflicts: #('Another Web Browser').
	self shouldnt: [ p1 = p2 ].

	p1 conflicts: p2 conflicts.
	self should: [ p1 = p2 ].
	self should: [ p1 hash = p2 hash ].

	p1 homepage: nil.
	p2 homepage: nil.
	self should: [ p1 = p2 ].
	self should: [ p1 hash = p2 hash ].

	p2 maintainer: 'Jane'.
	self shouldnt: [ p1 = p2 ].! !

!UPackageTestCase methodsFor: 'comparing' stamp: 'ls 2/13/2005 12:59'!
testEncoding
	self should: [ p1 = (UPackage decodeFromStringStream: (ReadStream on: p1 stringArrayEncoding)) ].! !

!UPackageTestCase methodsFor: 'comparing' stamp: 'ls 2/13/2005 13:29'!
testXML
	| xmlString stream readp1 readp2 readPackages |
	p2 version: (UVersion readFromString: '1.2').
	p1 description: 'blah blah <>&"'''.

	xmlString _ String streamContents: [ :str |
		str 
			nextPutAll: p1 xmlForExport;
			nextPutAll: p2 xmlForExport ].

	stream _ ReadStream on: xmlString.
	readPackages _ UPackage decodePackagesFromXMLStream: stream.

	self should: [ readPackages size = 2 ].
	readp1 _ readPackages first.
	readp2 _ readPackages second.

	self should: [ readp1 = p1 ].
	self should: [ readp2 = p2 ].
! !

TestCase subclass: #UUniverseServerTestCase
	instanceVariableNames: 'server'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Tests'!

TestCase subclass: #UVersionTestCase
	instanceVariableNames: 'typicalVersions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Universes-Tests'!

!UVersionTestCase methodsFor: 'initialize-release' stamp: 'ls 7/27/2004 21:12'!
setUp
	typicalVersions := #(
		'1'
		'2'
		'1.5.7'
		'1.5.8'
		'1.6.2'
		'1.5'
		'1.5a'
		'1.5b'
		'1.6'
		'alpha'
		'beta'
	) collect: [ :str | UVersion readFromString: str ].
	! !

!UVersionTestCase methodsFor: 'Running' stamp: 'ls 7/27/2004 17:19'!
testCompare
	self should: [ (UVersion readFromString: '1') < (UVersion readFromString: '2') ].
	self should: [ (UVersion readFromString: '1.5.7') < (UVersion readFromString: '1.5.8') ].
	self should: [ (UVersion readFromString: '1.5.7') < (UVersion readFromString: '1.6.2') ].
	self should: [ (UVersion readFromString: '1.5') < (UVersion readFromString: '1.5a') ].
	self should: [ (UVersion readFromString: '1.5a') < (UVersion readFromString: '1.5b') ].
	self should: [ (UVersion readFromString: '1.5b') < (UVersion readFromString: '1.6') ].! !

!UVersionTestCase methodsFor: 'Running' stamp: 'ls 7/27/2004 17:24'!
testFullOrder
	"check that all versions are in some order"

	typicalVersions do: [ :v1 |
		typicalVersions do: [ :v2 |
			self should: [
				(v1 < v2)
				or: [ (v2 < v1) 
				or: [ v1 = v2 ] ] ] ] ]



	! !

!UVersionTestCase methodsFor: 'Running' stamp: 'ls 7/28/2004 09:59'!
testHash
	typicalVersions do: [ :v |
		self should: [ v hash = v copy hash ] ].
	
	self should: [ (UVersion readFromString: '1.5a') hash = (UVersion readFromString: '1.5a') hash ].! !

!UVersionTestCase methodsFor: 'Running' stamp: 'ls 7/27/2004 17:23'!
testReversedComparisons
	"check that it is never the case that v1<v2 and v2<v1"

	typicalVersions do: [ :v1 |
		typicalVersions do: [ :v2 |
			self should: [ (v1 < v2) not  or:  [  (v2 < v1) not ] ] ] ].

	! !
UAccountEditor initialize!
UPackageEditor initialize!
UUniverse initialize!
UUniverseBrowser initialize!
UInstaller initialize!
UUniverseClient initialize!
UUniverseEditor initialize!
